// AccountNewHandler.cpp : Implementation of CAccountNewHandler

#include "stdafx.h"
#include "Module.h"
#include "EContactPerson.h"
#include "AccountNewHandler.h"

// IContactNewHandler implementation
STDMETHODIMP CAccountNewHandler::OnContactNewRequest (
	/*[in]*/  long       lCookie,
	/*[in]*/  IDispatch* pContact,
	/*[out, retval]*/ VARIANT* pvarName)
{
	HRESULT hr = NOERROR;

	CComVariant varName(L"MSCRM Firma");
	hr = varName.Detach (pvarName);
	return hr;
};

STDMETHODIMP CAccountNewHandler::OnContactNewExecute (
	/*[in]*/ long       lCookie,
	/*[in]*/ BSTR       bstrFolderID,
	/*[in]*/ IDispatch* pContact)
{
	CComQIPtr < IECOMContact, &__uuidof(IECOMContact) > spFirstContact(pContact);
	CComBSTR bstrURL(_AtlModule.m_bstrServerPort);
	bstrURL.Append(L"sfa/accts/edit.aspx?");

	CComBSTR bstrTmp;
	CComBSTR bstrTmp2;

	spFirstContact->get_Company(&bstrTmp2);
	if (bstrTmp2.Length() != 0)
	{
		APPEND(Company,                   "name");				  //Account: Company Name
	}
	else
	{
		APPEND(LastName,                  "name");            //Contact: Last Name
	}

	APPEND(PhoneBusiness,             "telephone1");          //Account: Business Phone
	APPEND(PhoneHome,                 "telephone2");          //Account: Home Phone
	APPEND(FaxBusiness,               "fax");                 //Account: Fax
	APPEND(WebPageURL,                "websiteurl");          //Account: Web Site
	APPEND(EMail,                     "emailaddress1");       //Account: E-mail
	
	APPEND(BusinessAddressStreet,     "address1_line1");      //Account: Street1
	APPEND(BusinessAddressCity,       "address1_city");       //Account: City
	APPEND(BusinessAddressPostalCode, "address1_postalcode"); //Account: ZIP/Postalcode
	APPEND(BusinessAddressCountry,    "address1_country");    //Account: Country/Region

	::ShellExecute(NULL, _T("open"), (LPCTSTR) bstrURL, NULL, NULL, SW_SHOWNORMAL);

	return NOERROR;
}

STDMETHODIMP CAccountNewHandler::IsContactFieldAvailable (
	/*[in]*/  long  lCookie,
	/*[in]*/  long lPropertyTag,
	/*[out, retval]*/ BOOL* pbRetC)
{
	*pbRetC = FALSE;
    switch (lPropertyTag)
    {
      // the entire list of all values are declared by MAPI ("mapitags.h")
      // the subset of values supported by ESTOS are:
      case 0x3A08001f: // PR_BUSINESS_TELEPHONE_NUMBER
      case 0x3A1B001f: // PR_BUSINESS2_TELEPHONE_NUMBER
        *pbRetC = TRUE; // return true if your database/contact supports the field specified by nPropertyTag 
    }

    return NOERROR;
}