// ContactNewHandler.cpp : Implementation of CContactNewHandler

#include "StdAfx.h"
#include "Module.h"
#include "EContactPerson.h"
#include "ContactNewHandler.h"

CContactNewHandler::CContactNewHandler(void)
{
	m_bstrAbout = L"MSCRM ContactNewHandler";
	m_bstrInfo = L"Copyright 2008";
}

// IContactNewHandler implementation
STDMETHODIMP CContactNewHandler::OnContactNewRequest (
	/*[in]*/  long       lCookie,
	/*[in]*/  IDispatch* pContact,
	/*[out, retval]*/ VARIANT* pvarName)
{
	HRESULT hr = NOERROR;

	CComVariant varName(L"MSCRM Kontakt");
	hr = varName.Detach (pvarName);
	return hr;
};

STDMETHODIMP CContactNewHandler::OnContactNewExecute (
	/*[in]*/ long       lCookie,
	/*[in]*/ BSTR       bstrFolderID,
	/*[in]*/ IDispatch* pContact)
{
	CComQIPtr < IECOMContact, &__uuidof(IECOMContact) > spFirstContact(pContact);
	CComBSTR bstrURL(_AtlModule.m_bstrServerPort);
	bstrURL.Append(L"sfa/conts/edit.aspx?");

	CComBSTR bstrTmp;
	APPEND(FirstName,                 "firstname");           //Contact: First Name
	APPEND(LastName,                  "lastname");            //Contact: Last Name
	APPEND(JobTitle,                  "jobtitle");            //Contact: Job Title
	APPEND(Company,                   "description");         //Contact: Company Name
	APPEND(PhoneBusiness,             "telephone1");          //Contact: Business Phone
	APPEND(PhoneHome,                 "telephone2");          //Contact: Home Phone
	APPEND(PhoneMobile,               "mobilephone");        //Contact: Mobile Phone
	APPEND(FaxBusiness,               "fax");                 //Contact: Fax
	APPEND(BusinessAddressStreet,     "address1_line1");      //Contact: Street1
	APPEND(BusinessAddressPostalCode, "address1_postalcode"); //Contact: ZIP/Postalcode
	APPEND(BusinessAddressCity,       "address1_city");       //Contact: City
	APPEND(BusinessAddressCountry,    "address1_country");    //Contact: Country/Region
	APPEND(EMail,                     "emailaddress1");       //Contact: E-mail
	APPEND(Department,                "department");          //Contact: Department
	APPEND(AssistantTelephoneNumber,  "assistantphone");      //Contact: Assistant Phone

	::ShellExecute(NULL, _T("open"), (LPCTSTR) bstrURL, NULL, NULL, SW_SHOWNORMAL);

	return NOERROR;
}

STDMETHODIMP CContactNewHandler::IsContactFieldAvailable (
	/*[in]*/  long  lCookie,
	/*[in]*/  ULONG ulPropertyTag,
	/*[out, retval]*/ BOOL* pbRetC)
{
    switch (ulPropertyTag)
    {
      // the entire list of all values are declared by MAPI ("mapitags.h")
      // the subset of values supported by ESTOS are:
      case 0x3A08001f: // PR_BUSINESS_TELEPHONE_NUMBER
      case 0x3A1B001f: // PR_BUSINESS2_TELEPHONE_NUMBER
      case 0x3A57001f: // PR_COMPANY_MAIN_PHONE_NUMBER
      case 0x3A2E001f: // PR_ASSISTANT_TELEPHONE_NUMBER
      case 0x3A09001f: // PR_HOME_TELEPHONE_NUMBER
      case 0x3A2F001f: // PR_HOME2_TELEPHONE_NUMBER
      case 0x3A1A001f: // PR_PRIMARY_TELEPHONE_NUMBER
      case 0x3A1C001f: // PR_MOBILE_TELEPHONE_NUMBER
      case 0x3A1E001f: // PR_CAR_TELEPHONE_NUMBER
      case 0x3A1D001f: // PR_RADIO_TELEPHONE_NUMBER
      case 0x3A21001f: // PR_PAGER_TELEPHONE_NUMBER
      case 0x3A1F001f: // PR_OTHER_TELEPHONE_NUMBER
      case 0x3A02001f: // PR_CALLBACK_TELEPHONE_NUMBER
      case 0x3A2D001f: // PR_ISDN_NUMBER
      case 0x3A4B001f: // PR_TTYTDD_PHONE_NUMBER
        *pbRetC = TRUE; // return true if your database/contact supports the field specified by nPropertyTag 
    }

    return NOERROR;
}
