#pragma once
#include "resource.h"       // main symbols
#include "ECrmAddIn.h"
#include "IClientAddInImpl.h"
#include "IContactNewHandlerImpl.h"

class ATL_NO_VTABLE CContactNewHandler :
	  public CComObjectRootEx < CComSingleThreadModel >
	, public CComCoClass < CContactNewHandler, &CLSID_ContactNewHandler >
	, public IClientAddInImpl < CContactNewHandler >
	, public IContactNewHandlerImpl < CContactNewHandler >
{
public:
	CContactNewHandler(void);

DECLARE_REGISTRY_RESOURCEID(IDR_CONTACTNEWHANDLER)

BEGIN_COM_MAP(CContactNewHandler)
	COM_INTERFACE_ENTRY(IClientAddIn)
	COM_INTERFACE_ENTRY_CHAIN(IContactNewHandlerImpl < CContactNewHandler >)
END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

// IContactNewHandler interface
	STDMETHOD (OnContactNewRequest) (
		/*[in]*/  long       lCookie,
		/*[in]*/  IDispatch* pContact,
		/*[out, retval]*/ VARIANT* pvarName);
	STDMETHOD (OnContactNewExecute) (
		/*[in]*/ long       lCookie,
		/*[in]*/ BSTR       bstrFolderID,
		/*[in]*/ IDispatch* pContact);
	STDMETHOD (IsContactFieldAvailable) (
		/*[in]*/  long  lCookie,
		/*[in]*/  ULONG ulPropertyTag,
		/*[out, retval]*/ BOOL* pbRetC);
};

OBJECT_ENTRY_AUTO(__uuidof(ContactNewHandler), CContactNewHandler)
