// NewLeadHandler.cpp : Implementation of CNewLeadHandler

#include "stdafx.h"
#include "Module.h"
#include "EContactPerson.h"
#include "NewLeadHandler.h"

// IContactNewHandler implementation
STDMETHODIMP CNewLeadHandler::OnContactNewRequest (
	/*[in]*/  long       lCookie,
	/*[in]*/  IDispatch* pContact,
	/*[out, retval]*/ VARIANT* pvarName)
{
	HRESULT hr = NOERROR;

	CComVariant varName(L"MSCRM Lead");
	hr = varName.Detach (pvarName);
	return hr;
};

STDMETHODIMP CNewLeadHandler::OnContactNewExecute (
	/*[in]*/ long       lCookie,
	/*[in]*/ BSTR       bstrFolderID,
	/*[in]*/ IDispatch* pContact)
{

	// ::MessageBox(NULL, _T("NewLeadHandler"), _T("\"New Lead\" selected"), MB_OK);

	CComQIPtr < IECOMContact, &__uuidof(IECOMContact) > spFirstContact(pContact);
	CComBSTR bstrURL(_AtlModule.m_bstrServerPort);
	bstrURL.Append(L"sfa/leads/edit.aspx?");

	CComBSTR bstrTmp;
	APPEND(DisplayName,               "subject");             //Lead: Theme
	APPEND(FirstName,                 "firstname");           //Lead: First Name
	APPEND(LastName,                  "lastname");            //Lead: Last Name
	APPEND(Company,                   "companyname");         //Lead: Company Name
	APPEND(PhoneBusiness,             "telephone1");          //Lead: Business Phone
	APPEND(PhoneHome,                 "telephone2");          //Lead: Home Phone
	APPEND(PhoneBusiness2,            "telephone3");          //Lead: Other Phone
	APPEND(PhoneMobile,               "mobilephone");        //Lead: Mobile Phone
	APPEND(JobTitle,                  "jobtitle");            //Lead: Job TitlePhone
	APPEND(FaxBusiness,               "fax");                 //Lead: Fax
	APPEND(PagerTelephoneNumber,      "pager");               //Lead: Pager
	APPEND(EMail,                     "emailaddress1");       //Lead: E-mail
	APPEND(WebPageURL,                "websiteurl");          //Lead: Web Site
	APPEND(BusinessAddressStreet,     "address1_line1");      //Lead: Street1
	APPEND(BusinessAddressCity,       "address1_city");       //Lead: City
	APPEND(BusinessAddressPostalCode, "address1_postalcode"); //Lead: ZIP/Postalcode
	APPEND(BusinessAddressCountry,    "address1_country");    //Lead: Country/Region

	::ShellExecute(NULL, _T("open"), (LPCTSTR) bstrURL, NULL, NULL, SW_SHOWNORMAL);


	return NOERROR;
}

STDMETHODIMP CNewLeadHandler::IsContactFieldAvailable (
	/*[in]*/  long  lCookie,
	/*[in]*/  ULONG ulPropertyTag,
	/*[out, retval]*/ BOOL* pbRetC)
{
	*pbRetC = FALSE;
    switch (ulPropertyTag)
    {
      // the entire list of all values are declared by MAPI ("mapitags.h")
      // the subset of values supported by ESTOS are:
      case 0x3A08001f: // PR_BUSINESS_TELEPHONE_NUMBER
      case 0x3A1C001f: // PR_MOBILE_TELEPHONE_NUMBER
        *pbRetC = TRUE; // return true if your database/contact supports the field specified by nPropertyTag 
    }

    return NOERROR;
}

