// NewLeadHandler.h : Declaration of the CNewLeadHandler

#pragma once
#include "resource.h"       // main symbols
#include "ECrmAddIn.h"
#include "IClientAddInImpl.h"
#include "IContactNewHandlerImpl.h"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

// CNewLeadHandler
class ATL_NO_VTABLE CNewLeadHandler :
	  public CComObjectRootEx < CComSingleThreadModel >
	, public CComCoClass < CNewLeadHandler, &CLSID_NewLeadHandler >
	, public IClientAddInImpl < CNewLeadHandler >
	, public IContactNewHandlerImpl < CNewLeadHandler >
{
public:
	DECLARE_REGISTRY_RESOURCEID(IDR_NEWLEADHANDLER)

	BEGIN_COM_MAP(CNewLeadHandler)
	COM_INTERFACE_ENTRY(IClientAddIn)
	COM_INTERFACE_ENTRY_CHAIN(IContactNewHandlerImpl < CNewLeadHandler >)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

// IContactNewHandler interface
	STDMETHOD (OnContactNewRequest) (
		/*[in]*/  long       lCookie,
		/*[in]*/  IDispatch* pContact,
		/*[out, retval]*/ VARIANT* pvarName);
	STDMETHOD (OnContactNewExecute) (
		/*[in]*/ long       lCookie,
		/*[in]*/ BSTR       bstrFolderID,
		/*[in]*/ IDispatch* pContact);
	STDMETHOD (IsContactFieldAvailable) (
		/*[in]*/  long  lCookie,
		/*[in]*/  ULONG ulPropertyTag,
		/*[out, retval]*/ BOOL* pbRetC);
};

OBJECT_ENTRY_AUTO(__uuidof(NewLeadHandler), CNewLeadHandler)
