// CmdHook.h : Declaration of the CCmdHook

#pragma once
#include "resource.h"       // main symbols
#include "EProCallExt.h"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

// CCmdHook
class ATL_NO_VTABLE CCmdHook :
	  public CComObjectRootEx < CComSingleThreadModel >
	, public CComCoClass < CCmdHook, &CLSID_CmdHook >
	, public ECtiClientLib::IClientAddIn
	, public IDispatchImpl < ECtiClientLib::ICmdHook, &__uuidof(ECtiClientLib::ICmdHook), &__uuidof(ECtiClientLib::__ECtiClientLib) >
{
public:
	DECLARE_REGISTRY_RESOURCEID(IDR_CMDHOOK)

	BEGIN_COM_MAP(CCmdHook)
		COM_INTERFACE_ENTRY(ECtiClientLib::IClientAddIn)
		COM_INTERFACE_ENTRY(ECtiClientLib::ICmdHook)
		COM_INTERFACE_ENTRY2(IDispatch, ECtiClientLib::ICmdHook)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	// IClientAddIn interface
	STDMETHOD(raw_GetAbout) (/*out*/ BSTR* pbstrAbout, /*out*/ BSTR* pbstrInfo);
	STDMETHOD(raw_OnLoad) (/*in*/ IDispatch* pClientApplication) { return E_NOTIMPL; }
	STDMETHOD(raw_OnUnload) () { return E_NOTIMPL; }

	// ICmdHook interface
	STDMETHOD(raw_IsHandled) (/*[in]*/ IDispatch* pObject, /*[in]*/ ECtiClientLib::ENUM_CMDID eCmdID, /*[out,retval]*/ long* pbRetC);
	STDMETHOD(raw_Execute) (/*[in]*/ IDispatch* pObject, /*[in]*/ ECtiClientLib::ENUM_CMDID eCmdID, /*[out,retval]*/ long* pbRetC);
};

OBJECT_ENTRY_AUTO(__uuidof(CmdHook), CCmdHook)
