#pragma once

template < class T, const GUID* plibid = &CAtlModule::m_libid, WORD wMajor = 1, WORD wMinor = 0 >
class ATL_NO_VTABLE IContactNewHandlerImpl :
	  public IParseDisplayName
	, public IDispatchImpl < IContactNewHandler, &__uuidof(IContactNewHandler), plibid, wMajor, wMinor >
{
public:
  BEGIN_COM_MAP(IContactNewHandlerImpl < T > )
	COM_INTERFACE_ENTRY(IParseDisplayName)
    COM_INTERFACE_ENTRY(IContactNewHandler)
    COM_INTERFACE_ENTRY2(IDispatch, IContactNewHandler)
  END_COM_MAP()

// interface IParseDisplayName
public:
	STDMETHOD(ParseDisplayName) (
		IBindCtx*  pbc,
		LPOLESTR   lpszDisplayName,
		ULONG*     pchEaten,
		IMoniker** ppMoniker)
	{
		HRESULT hr = MK_E_NOOBJECT;

		/*
#pragma message ( __FILE__ "(" STRING(__LINE__) ") : ToDo: " "mit dem hartcodierten namen geht das natuerlich nicht aber vorlaeufig soll es genuegen")
		if (0 == wcscmp(L"@EProCallExt.ContactNewHandler", lpszDisplayName))
		{
			*pchEaten = wcslen(lpszDisplayName);
			hr = ::CreatePointerMoniker(GetUnknown(), ppMoniker);
		} */
		return hr;
	}

// IContactNewHandler implementation
public:
	STDMETHOD (OnContactNewRequest) (
		/*[in]*/  long       lCookie,
		/*[in]*/  IDispatch* pContact,
		/*[out, retval]*/ VARIANT* pvarName)
	{
		HRESULT hr = NOERROR;

		CComVariant varName(L"SDKSample AddIn");
		hr = varName.Detach (pvarName);
		return hr;
	};

	STDMETHOD (QueryOptions) (
		/*[in]*/          long  lCookie,
		/*[out, retval]*/ long* plOptions)
	{
		return E_NOTIMPL;
	}

	STDMETHOD (IsContactFieldAvailable) (
		/*[in]*/  long lCookie,
		/*[in]*/  long lPropertyTag,
		/*[out, retval]*/ BOOL* pbRetC)
	{
		return E_NOTIMPL;
	}

	STDMETHOD (OnContactNewExecute) (
		/*[in]*/ long       lCookie,
		/*[in]*/ BSTR       bstrFolderID,
		/*[in]*/ IDispatch* pContact)
	{
		CComQIPtr < IECOMContact, &__uuidof(IECOMContact) > spContact(pContact);
		CComBSTR bstrDisplayName;
		if (spContact)
			spContact->get_DisplayName(&bstrDisplayName);

		TCHAR szMsg[0x100];
		_sntprintf_s(szMsg, 0xff, _T("FromInsideAddIn::OnContactNewExecute() on %ls"), (BSTR) bstrDisplayName);
		szMsg[0xff] = _T('\0');
		::MessageBox(NULL, szMsg, _T("SDKSample ContactNewHandler"), MB_OK | MB_ICONINFORMATION);

		return NOERROR;
	}

	STDMETHOD (OnContactNewChooseFolder) (
		/*[in]*/ long              lCookie,
		/*[in]*/ long              lParent,
		/*[in]*/ IDispatch*        pContact,
		/*[out, retval]*/ VARIANT* pvarFolderID)
	{
		return E_NOTIMPL;
	}

	STDMETHOD (GetDefaultLocationFromType) (
		/*[in]*/ long   lCookie,
		/*[in]*/ long   lFolderType,
		/*[out]*/ BSTR* pbstrFolderStoreID,
		/*[out]*/ BSTR* pbstrFolderEntryID)
	{
		return E_NOTIMPL;
	}

	STDMETHOD (GetDisplayNamesFromIDs) (
		/*[in]*/ long   lCookie,
		/*[in]*/ BSTR   bstrFolderStoreID,
		/*[in]*/ BSTR   bstrFolderEntryID,
		/*[out]*/ BSTR* pbstrStoreName,
		/*[out]*/ BSTR* pbstrFolderName)
	{
		return E_NOTIMPL;
	}

	STDMETHOD (OnContactOpen) (
		/* [in] */ long       lCookie,
		/* [in] */ IDispatch* pContact)
	{
		CComQIPtr < IECOMContact, &__uuidof(IECOMContact) > spContact(pContact);
		CComBSTR bstrDisplayName;
		if (spContact)
			spContact->get_DisplayName(&bstrDisplayName);

		TCHAR szMsg[0x100];
		_sntprintf_s(szMsg, 0xff, _T("FromInsideAddIn::OnContactOpen() on %ls"), (BSTR) bstrDisplayName);
		szMsg[0xff] = _T('\0');
		::MessageBox(NULL, szMsg, _T("SDKSample ContactNewHandler"), MB_OK | MB_ICONINFORMATION);

		return NOERROR;
	}
};
