#pragma once

template < class T, const GUID* plibid = &CAtlModule::m_libid, WORD wMajor = 1, WORD wMinor = 0 >
class ATL_NO_VTABLE ICtxMnuHandlerImpl :
	public IDispatchImpl < ICtxMnuHandler, &__uuidof(ICtxMnuHandler), plibid, wMajor, wMinor >
{
public:
	BEGIN_COM_MAP(ICtxMnuHandlerImpl < T > )
		COM_INTERFACE_ENTRY(ICtxMnuHandler)
		COM_INTERFACE_ENTRY2(IDispatch, ICtxMnuHandler)
	END_COM_MAP()

// ICtxMnuHandler implementation
public:
	STDMETHOD (OnCtxMenuCreate) (
		/*[in]*/ IDispatch* pCmdBar,
		/*[in]*/ IDispatch* pContacts)
	{
		T* pT = static_cast < T* >(this);

		HRESULT hr = NOERROR;
		CComQIPtr < IPCCmdBar, &__uuidof(IPCCmdBar) > spCmdBar(pCmdBar);

		LPOLESTR szGroupGUID = NULL;
		hr = ::StringFromCLSID ((REFGUID) CONTACT_NEW_GROUP_GUID, &szGroupGUID);
		hr = spCmdBar->Add (CComBSTR(szGroupGUID), 0x38f5, CComBSTR(_T("&SMS Me")), 0, NULL);

		CComBSTR bstrBitmap(_T("C:\\Program Files (x86)\\Microsoft Visual Studio 8\\VC\\VCAddClass\\Provider.ico"));
		TCHAR szModuleFileName[_MAX_PATH + 1];
		::GetModuleFileName(NULL, szModuleFileName, _MAX_PATH);
		hr = spCmdBar->Add (CComBSTR(szGroupGUID), 3, CComBSTR(_T("&SMS Colored")), LR_DEFAULTSIZE | LR_LOADFROMFILE, bstrBitmap);
		::CoTaskMemFree (szGroupGUID);
		return hr;
	}

	STDMETHOD (OnCtxMenuItemClicked) (
		/*[in]*/ long       lCmdID,
		/*[in]*/ IDispatch* pContacts)
	{
		T* pT = static_cast<T*>(this);

		HRESULT hr = E_INVALIDARG;
		CComQIPtr < IECOMContacts, &__uuidof(IECOMContacts) > spContacts(pContacts);
		CComQIPtr < IECOMContact, &__uuidof(IECOMContact) > spFirstContact;
		long lCount = 0L;
		hr = spContacts->get_Count(&lCount);
		if (lCount)
		{
			IUnknownPtr spUnk;
			hr = spContacts->get_Item(1 ,&spUnk); // index is 1 Based
			spFirstContact = spUnk;
		}

		switch (lCmdID)
		{
			case 0x38f5:
				{
				CComBSTR bstrDisplayName;
				if (spFirstContact)
					spFirstContact->get_DisplayName(&bstrDisplayName);

				TCHAR szMsg[0x100];
				_sntprintf_s(szMsg, 0xff, _T("FromInsideAddIn::OnCtxMenuItemClicked() on (%d items) FirstContact is: %ls"), lCount, (BSTR) bstrDisplayName);
				szMsg[0xff] = _T('\0');
				::MessageBox(NULL, szMsg, _T("SDK Sample ContextMenuHandler"), MB_OK | MB_ICONINFORMATION);
				hr = NOERROR;
				break;
				}

			default:
				hr = E_INVALIDARG;
				break;
		}

		return hr;
	}
};
