// IRemoteContactImpl.h

#pragma once

// might be usefull but requires some additional headers
#include <libs\EBase\include\StdString.h>
#include <libs\etool\include\ENetDatabaseContact.h>
#include <libs\ENetConnection_Common\include\EDataConverterContact.h>
#include <libs\ENetConnection_Client\generated\ENetROSEInterface.h>

#define COPYMEMBER_RC_ASN(NameDst, NameSrc) if (NULL != pAsnContact->u8s##NameSrc) m_bstr##NameDst = pAsnContact->u8s##NameSrc ->getUTF16().c_str()

#define REMOTECONTACT(macro)  macro(CurrentNumberSC); \
  macro(DatabaseName); \
  macro(EntryIDDB); \
  macro(EntryIDStore); \
  macro(EntryID); \
  macro(DirectWebLink); \
  macro(DisplayName); \
  macro(FirstName); \
  macro(LastName); \
  macro(JobTitle); \
  macro(Company); \
  macro(Department); \
  macro(OfficeRoomNumber); \
  macro(AddressStreet); \
  macro(AddressPostalCode); \
  macro(AddressCity); \
  macro(AddressState); \
  macro(AddressCountry); \
  macro(EMail); \
  macro(WebPageURL); \
  macro(PhoneBusiness); \
  macro(PhoneBusiness2); \
  macro(PhoneHome); \
  macro(PhoneMobile); \
  macro(PhonePager); \
  macro(FaxBusiness); \
  macro(FaxHome); \
  macro(Notes); \
  macro(Custom0); \
  macro(Custom1); \
  macro(Custom2); \
  macro(Custom3); \
  macro(Custom4); \
  macro(Custom5); \
  macro(Custom6); \
  macro(Custom7); \
  macro(Custom8); \
  macro(Custom9);

// these macros depends on the list macro above.
#define DECLARE_MEMBER(MemberName)  CComBSTR m_bstr##MemberName
#define PROPERTY_IMPL(IName)	    STDMETHOD (get_##IName) (BSTR* pVal) \
								    { \
									  if (NULL == pVal) \
										return E_POINTER; \
									  AFX_MANAGE_STATE(AfxGetStaticModuleState()); \
									  *pVal = m_bstr##IName.Copy(); \
									  return S_OK; \
								    }

template < class T,
           class I,
           const IID* piid = &__uuidof(I),
		   const GUID* plibid = &CAtlModule::m_libid,
		   WORD wMajor = 1,
           WORD wMinor = 0,
           class tihclass = CComTypeInfoHolder >
class ATL_NO_VTABLE IRemoteContactImpl :
	public IDispatchImpl < I, piid, plibid, wMajor, wMinor >
{
public:
	IRemoteContactImpl (void)
	{
	}

	~IRemoteContactImpl (void)
	{
	}

  typedef IRemoteContactImpl < T, I, piid, plibid, wMajor, wMinor > _class;
  BEGIN_COM_MAP( _class )
    COM_INTERFACE_ENTRY(I)
	COM_INTERFACE_ENTRY(IDispatch)
  END_COM_MAP()

// COM-Interface IRemoteContact
public:
	REMOTECONTACT(PROPERTY_IMPL)

// C/C++ Interface implementation
	virtual HRESULT FillRemoteContact (ENetDatabaseContact* pDBContact)
	{
		T* pThis(dynamic_cast < T* > (this));

		if (NULL == pDBContact)
			return E_INVALIDARG;

		// Custom Fields
		m_bstrCustom0 = pDBContact->GetFieldValue(_T("custom0"));
		m_bstrCustom1 = pDBContact->GetFieldValue(_T("custom1"));
		m_bstrCustom2 = pDBContact->GetFieldValue(_T("custom2"));
		m_bstrCustom3 = pDBContact->GetFieldValue(_T("custom3"));
		m_bstrCustom4 = pDBContact->GetFieldValue(_T("custom4"));
		m_bstrCustom5 = pDBContact->GetFieldValue(_T("custom5"));
		m_bstrCustom6 = pDBContact->GetFieldValue(_T("custom6"));
		m_bstrCustom7 = pDBContact->GetFieldValue(_T("custom7"));
		m_bstrCustom8 = pDBContact->GetFieldValue(_T("custom8"));
		m_bstrCustom9 = pDBContact->GetFieldValue(_T("custom9"));

		return NOERROR;
	}

	virtual HRESULT FillRemoteContact (SNACC::AsnNetDatabaseContact* pAsnContact)
	{
		T* pThis(dynamic_cast < T* > (this));

		if (NULL == pAsnContact)
			return E_INVALIDARG;

		COPYMEMBER_RC_ASN(DatabaseName, DatabaseName);
		COPYMEMBER_RC_ASN(EntryIDDB, EntryIDDB);
		COPYMEMBER_RC_ASN(EntryIDStore, EntryIDStore);
		COPYMEMBER_RC_ASN(EntryID, EntryID);
		COPYMEMBER_RC_ASN(DirectWebLink, DirectWebLink);
		COPYMEMBER_RC_ASN(DisplayName, DisplayName);
		COPYMEMBER_RC_ASN(FirstName, FirstName);
		COPYMEMBER_RC_ASN(LastName, LastName);
		COPYMEMBER_RC_ASN(JobTitle, JobTitle);
		COPYMEMBER_RC_ASN(Company, Company);
		COPYMEMBER_RC_ASN(Department, Department);
		COPYMEMBER_RC_ASN(OfficeRoomNumber, OfficeRoomNumber);
		COPYMEMBER_RC_ASN(AddressStreet, BusinessAddressStreet);
		COPYMEMBER_RC_ASN(AddressPostalCode, BusinessAddressPostalCode);
		COPYMEMBER_RC_ASN(AddressCity, BusinessAddressCity);
		COPYMEMBER_RC_ASN(AddressState, BusinessAddressState);
		COPYMEMBER_RC_ASN(AddressCountry, BusinessAddressCountry);
		COPYMEMBER_RC_ASN(EMail, EMail);
		COPYMEMBER_RC_ASN(WebPageURL, WebPageURL);
		COPYMEMBER_RC_ASN(PhoneBusiness, PhoneBusiness);
		COPYMEMBER_RC_ASN(PhoneBusiness2, PhoneBusiness2);
		COPYMEMBER_RC_ASN(PhoneHome, PhoneHome);
		COPYMEMBER_RC_ASN(PhoneMobile, PhoneMobile);
		COPYMEMBER_RC_ASN(PhonePager, PagerTelephoneNumber);
		COPYMEMBER_RC_ASN(FaxBusiness, FaxBusiness);
		COPYMEMBER_RC_ASN(FaxHome, FaxHome);
		COPYMEMBER_RC_ASN(Notes, Body);

		// Custom Fields
		ENetDatabaseContact Contact;
		EDataConverterContact::AsnNetDatabaseContactToNetDatabaseContact(*pAsnContact, Contact);
		HRESULT hr = FillRemoteContact(&Contact);
		return hr;
	}

// attributes
	REMOTECONTACT(DECLARE_MEMBER)
};
