using System;
using System.Windows.Forms;
using ENETTSCLib;
using Application = System.Windows.Forms.Application;

namespace CSNetTSC
{
	/// <summary>
	/// Zusammenfassung fr Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
        private ENETTSCLib.Application enettsc = null;
        private string strServer;
        private string strPort;
        private string strUsername;
        private string strPassword;
        private ENETTSCLib.Line myLine = null;

        private int cnt = 0;

        private static long ELINEERR_OPERATIONUNAVAIL = 0x80000049;
        
        private System.Windows.Forms.TreeView tvLineView;
        private System.Windows.Forms.Label lblServername;
        private System.Windows.Forms.TextBox tbServername;
        private System.Windows.Forms.Label lblPortnumber;
        private System.Windows.Forms.TextBox tbPortnumber;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.Button btConnect;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Button btClearEvents;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.TextBox tbPassword;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.TextBox tbUsername;
        private System.Windows.Forms.ListBox lbEventList;
        private System.Windows.Forms.MenuItem cmiMakeCall;
        private System.Windows.Forms.MenuItem cmiHangup;
        private System.Windows.Forms.ContextMenu cmLineMenu;
        private System.Windows.Forms.MenuItem miAnswerCall;
        private System.Windows.Forms.MenuItem miRedirectTo;
        private System.Windows.Forms.MenuItem miUnhold;
        private System.Windows.Forms.MenuItem miMergeCalls;
        private System.Windows.Forms.MenuItem miStartCallRecording;
        private System.Windows.Forms.MenuItem miSwapHold;
        private System.Windows.Forms.MenuItem miGetActiveCall;
        private System.Windows.Forms.MenuItem miSendMessage;

		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

            
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
            this.btConnect = new System.Windows.Forms.Button();
            this.tvLineView = new System.Windows.Forms.TreeView();
            this.cmLineMenu = new System.Windows.Forms.ContextMenu();
            this.cmiMakeCall = new System.Windows.Forms.MenuItem();
            this.cmiHangup = new System.Windows.Forms.MenuItem();
            this.miAnswerCall = new System.Windows.Forms.MenuItem();
            this.miRedirectTo = new System.Windows.Forms.MenuItem();
            this.miUnhold = new System.Windows.Forms.MenuItem();
            this.miMergeCalls = new System.Windows.Forms.MenuItem();
            this.miStartCallRecording = new System.Windows.Forms.MenuItem();
            this.miSwapHold = new System.Windows.Forms.MenuItem();
            this.miGetActiveCall = new System.Windows.Forms.MenuItem();
            this.miSendMessage = new System.Windows.Forms.MenuItem();
            this.lblServername = new System.Windows.Forms.Label();
            this.tbServername = new System.Windows.Forms.TextBox();
            this.lblPortnumber = new System.Windows.Forms.Label();
            this.tbPortnumber = new System.Windows.Forms.TextBox();
            this.lbEventList = new System.Windows.Forms.ListBox();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.label3 = new System.Windows.Forms.Label();
            this.tbPassword = new System.Windows.Forms.TextBox();
            this.label4 = new System.Windows.Forms.Label();
            this.tbUsername = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.btClearEvents = new System.Windows.Forms.Button();
            this.label2 = new System.Windows.Forms.Label();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // btConnect
            // 
            this.btConnect.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.btConnect.Location = new System.Drawing.Point(152, 112);
            this.btConnect.Name = "btConnect";
            this.btConnect.Size = new System.Drawing.Size(152, 24);
            this.btConnect.TabIndex = 4;
            this.btConnect.Text = "Connect";
            this.btConnect.Click += new System.EventHandler(this.btConnect_Click);
            // 
            // tvLineView
            // 
            this.tvLineView.ContextMenu = this.cmLineMenu;
            this.tvLineView.HotTracking = true;
            this.tvLineView.Location = new System.Drawing.Point(208, 184);
            this.tvLineView.Name = "tvLineView";
            this.tvLineView.Size = new System.Drawing.Size(272, 208);
            this.tvLineView.Sorted = true;
            this.tvLineView.TabIndex = 1;
            this.tvLineView.TabStop = false;
            this.tvLineView.MouseDown += new System.Windows.Forms.MouseEventHandler(this.tvLineView_MouseDown);
            // 
            // cmLineMenu
            // 
            this.cmLineMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.cmiMakeCall,
            this.cmiHangup,
            this.miAnswerCall,
            this.miRedirectTo,
            this.miUnhold,
            this.miMergeCalls,
            this.miStartCallRecording,
            this.miSwapHold,
            this.miGetActiveCall,
            this.miSendMessage});
            // 
            // cmiMakeCall
            // 
            this.cmiMakeCall.Index = 0;
            this.cmiMakeCall.Text = "Make Call";
            this.cmiMakeCall.Click += new System.EventHandler(this.cmiMakeCall_Click);
            // 
            // cmiHangup
            // 
            this.cmiHangup.Index = 1;
            this.cmiHangup.Text = "Hangup";
            this.cmiHangup.Click += new System.EventHandler(this.cmiHangup_Click);
            // 
            // miAnswerCall
            // 
            this.miAnswerCall.Index = 2;
            this.miAnswerCall.Text = "Answer";
            this.miAnswerCall.Click += new System.EventHandler(this.miAnswerCall_Click);
            // 
            // miRedirectTo
            // 
            this.miRedirectTo.Index = 3;
            this.miRedirectTo.Text = "Redirect To";
            this.miRedirectTo.Click += new System.EventHandler(this.miRedirectTo_Click);
            // 
            // miUnhold
            // 
            this.miUnhold.Index = 4;
            this.miUnhold.Text = "Unhold";
            this.miUnhold.Click += new System.EventHandler(this.miUnhold_Click);
            // 
            // miMergeCalls
            // 
            this.miMergeCalls.Index = 5;
            this.miMergeCalls.Text = "MergeCalls";
            this.miMergeCalls.Click += new System.EventHandler(this.miMergeCalls_Click);
            // 
            // miStartCallRecording
            // 
            this.miStartCallRecording.Index = 6;
            this.miStartCallRecording.Text = "StartCallRecording";
            this.miStartCallRecording.Click += new System.EventHandler(this.miStartCallRecording_Click);
            // 
            // miSwapHold
            // 
            this.miSwapHold.Index = 7;
            this.miSwapHold.Text = "Swap Hold";
            this.miSwapHold.Click += new System.EventHandler(this.miSwapHold_Click);
            // 
            // miGetActiveCall
            // 
            this.miGetActiveCall.Index = 8;
            this.miGetActiveCall.Text = "Get Active Call";
            this.miGetActiveCall.Click += new System.EventHandler(this.miGetActiveCall_Click);
            // 
            // miSendMessage
            // 
            this.miSendMessage.Index = 9;
            this.miSendMessage.Text = "Send Message";
            this.miSendMessage.Click += new System.EventHandler(this.miSendMessage_Click);
            // 
            // lblServername
            // 
            this.lblServername.Location = new System.Drawing.Point(16, 24);
            this.lblServername.Name = "lblServername";
            this.lblServername.Size = new System.Drawing.Size(192, 16);
            this.lblServername.TabIndex = 2;
            this.lblServername.Text = "Servername:";
            // 
            // tbServername
            // 
            this.tbServername.Location = new System.Drawing.Point(16, 40);
            this.tbServername.Name = "tbServername";
            this.tbServername.Size = new System.Drawing.Size(192, 20);
            this.tbServername.TabIndex = 0;
            this.tbServername.Text = "localhost";
            // 
            // lblPortnumber
            // 
            this.lblPortnumber.Location = new System.Drawing.Point(16, 64);
            this.lblPortnumber.Name = "lblPortnumber";
            this.lblPortnumber.Size = new System.Drawing.Size(192, 16);
            this.lblPortnumber.TabIndex = 4;
            this.lblPortnumber.Text = "Portnumber:";
            // 
            // tbPortnumber
            // 
            this.tbPortnumber.Location = new System.Drawing.Point(16, 80);
            this.tbPortnumber.Name = "tbPortnumber";
            this.tbPortnumber.Size = new System.Drawing.Size(192, 20);
            this.tbPortnumber.TabIndex = 1;
            this.tbPortnumber.Text = "7222";
            // 
            // lbEventList
            // 
            this.lbEventList.Location = new System.Drawing.Point(8, 184);
            this.lbEventList.Name = "lbEventList";
            this.lbEventList.Size = new System.Drawing.Size(184, 173);
            this.lbEventList.TabIndex = 6;
            this.lbEventList.TabStop = false;
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.tbPassword);
            this.groupBox1.Controls.Add(this.label4);
            this.groupBox1.Controls.Add(this.tbUsername);
            this.groupBox1.Controls.Add(this.lblPortnumber);
            this.groupBox1.Controls.Add(this.tbPortnumber);
            this.groupBox1.Controls.Add(this.btConnect);
            this.groupBox1.Controls.Add(this.lblServername);
            this.groupBox1.Controls.Add(this.tbServername);
            this.groupBox1.Location = new System.Drawing.Point(8, 8);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(472, 152);
            this.groupBox1.TabIndex = 7;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Configuration";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(256, 64);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(200, 16);
            this.label3.TabIndex = 8;
            this.label3.Text = "Password:";
            // 
            // tbPassword
            // 
            this.tbPassword.Location = new System.Drawing.Point(256, 80);
            this.tbPassword.Name = "tbPassword";
            this.tbPassword.Size = new System.Drawing.Size(200, 20);
            this.tbPassword.TabIndex = 3;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(256, 24);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(200, 16);
            this.label4.TabIndex = 6;
            this.label4.Text = "Username:";
            // 
            // tbUsername
            // 
            this.tbUsername.Location = new System.Drawing.Point(256, 40);
            this.tbUsername.Name = "tbUsername";
            this.tbUsername.Size = new System.Drawing.Size(200, 20);
            this.tbUsername.TabIndex = 2;
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 168);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(152, 16);
            this.label1.TabIndex = 6;
            this.label1.Text = "Events:";
            // 
            // btClearEvents
            // 
            this.btClearEvents.Location = new System.Drawing.Point(8, 368);
            this.btClearEvents.Name = "btClearEvents";
            this.btClearEvents.Size = new System.Drawing.Size(184, 24);
            this.btClearEvents.TabIndex = 6;
            this.btClearEvents.TabStop = false;
            this.btClearEvents.Text = "Clear Eventlist";
            this.btClearEvents.Click += new System.EventHandler(this.btClearEvents_Click);
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(208, 168);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(264, 16);
            this.label2.TabIndex = 8;
            this.label2.Text = "Lines and Calls (see Contextmenu for Options):";
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(488, 406);
            this.ContextMenu = this.cmLineMenu;
            this.Controls.Add(this.label2);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.lbEventList);
            this.Controls.Add(this.tvLineView);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.btClearEvents);
            this.Name = "MainForm";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "C# - ENetTSC Sample";
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

        private void addEventEntry(string entry)
        {
            lbEventList.Items.Add(entry);
            lbEventList.SelectedIndex = lbEventList.Items.Count-1;
        }

        private void btConnect_Click(object sender, System.EventArgs e)
        {
            strServer = tbServername.Text;
            strPort = tbPortnumber.Text;
            strUsername = tbUsername.Text;
            strPassword = tbPassword.Text;

            if(enettsc != null)
            {
                enettsc.Dispose();
                enettsc = null;
            }

            enettsc = new ENETTSCLib.ApplicationClass();

            enettsc.SetServer(strServer, int.Parse(strPort));
            enettsc.SetLogin(strUsername, strPassword);

            try
            {
                enettsc.Connect();

                myLine = enettsc.FirstLine;

                enettsc.OnCallBusy += new _IApplicationEvents_OnCallBusyEventHandler(enettsc_OnCallBusy);
                enettsc.OnCallConferenced += new ENETTSCLib._IApplicationEvents_OnCallConferencedEventHandler(enettsc_OnCallConferenced);
                enettsc.OnCallConnected += new ENETTSCLib._IApplicationEvents_OnCallConnectedEventHandler(enettsc_OnCallConnected);
                enettsc.OnCallDestroyed += new ENETTSCLib._IApplicationEvents_OnCallDestroyedEventHandler(enettsc_OnCallDestroyed);
                enettsc.OnCallDialing += new ENETTSCLib._IApplicationEvents_OnCallDialingEventHandler(enettsc_OnCallDialing);
                enettsc.OnCallDisconnected += new ENETTSCLib._IApplicationEvents_OnCallDisconnectedEventHandler(enettsc_OnCallDisconnected);
                enettsc.OnCallHold +=new ENETTSCLib._IApplicationEvents_OnCallHoldEventHandler(enettsc_OnCallHold);
                enettsc.OnCallOffering += new ENETTSCLib._IApplicationEvents_OnCallOfferingEventHandler(enettsc_OnCallOffering);
                enettsc.OnCallRingback += new ENETTSCLib._IApplicationEvents_OnCallRingbackEventHandler(enettsc_OnCallRingback);
                enettsc.OnNewUserMessage += new ENETTSCLib._IApplicationEvents_OnNewUserMessageEventHandler(enettsc_OnNewUserMessage);
                enettsc.OnRemotePartyChanged += new ENETTSCLib._IApplicationEvents_OnRemotePartyChangedEventHandler(enettsc_OnRemotePartyChanged);
				enettsc.OnDisconnect += new _IApplicationEvents_OnDisconnectEventHandler(enettsc_OnDisconnect);
				enettsc.OnReconnect +=new _IApplicationEvents_OnReconnectEventHandler(enettsc_OnReconnect);
                foreach(ENETTSCLib.Line line in enettsc.Lines)
                {
                    line.Open();                
                }

                refreshTreeView();    


            }
            catch(Exception ex)
            {
                System.Windows.Forms.MessageBox.Show(ex.Message);
            }
        }

        private void btClearEvents_Click(object sender, System.EventArgs e)
        {
            lbEventList.Items.Clear();
        }

		private delegate void RefreshTreeViewDelegate();
        private void refreshTreeView()
        {
            tvLineView.Nodes.Clear();

            foreach(ENETTSCLib.Line line in enettsc.Lines)
            {
                LineTreeNode node = new LineTreeNode(line);
                tvLineView.Nodes.Add(node);
                foreach(ENETTSCLib.Call call in line.Calls)
                {
                    CallTreeNode anode = new CallTreeNode(call);
                    node.Nodes.Add(anode);
                }
            }              
      
            tvLineView.ExpandAll();
        }

        private TreeNode searchCallNode(string callID)
        {
            foreach(TreeNode tnLine in tvLineView.Nodes)
            {
                foreach(TreeNode tnCall in tnLine.Nodes)
                {
                    string name = tnCall.Text;
                    if(name.StartsWith(callID))
                        return tnCall;
                }
            }
            return null;
        }

        private TreeNode getLineNode(string lineID)
        {
            foreach(TreeNode tnLine in tvLineView.Nodes)
            {
                string name = tnLine.Text;
                if(name.StartsWith(lineID))
                    return tnLine;
            }
            return null;
        }

        private void removeCallNode(string callID)
        {
            foreach(TreeNode tnLine in tvLineView.Nodes)
            {
                foreach(TreeNode tnCall in tnLine.Nodes)
                {
                    string name = tnCall.Text;
                    if(name.StartsWith(callID))
                    {
                        tnLine.Nodes.Remove(tnCall);
                        return;
                    }
                }
            }
        }

        private void addCallNode(ENETTSCLib.Call pCall)
        {
            foreach(ENETTSCLib.Line line in enettsc.Lines)
            {
                foreach(ENETTSCLib.Call call in line.Calls)
                {
                    if(call.ID == pCall.ID)
                    {
                        string tmp = String.Format("[L{0:X8}]", line.ID);
                        TreeNode ln = getLineNode(tmp); 
                        if(ln != null)
                        {
                            CallTreeNode anode = new CallTreeNode(pCall);
                            ln.Nodes.Add(anode);
                        }
                    }
                }
            }              
      
            tvLineView.ExpandAll();
        }

        private void enettsc_OnCallBusy(object _pCall)
        {
            ENETTSCLib.Call pCall = (ENETTSCLib.Call)_pCall;

            addEventEntry("OnCallBusy");
            TreeNode tn = searchCallNode("C" + pCall.ID);
            if(tn == null)
            {
                addCallNode(pCall);
                tvLineView.ExpandAll();
            }
            tn = searchCallNode("C" + pCall.ID);
            if(tn != null)
            {
                tn.Text = "C" + pCall.ID + ": Call busy " + pCall.RemoteContact.DisplayName + " [" + pCall.CurrentNumber + "]";
                tvLineView.ExpandAll();
            }
        }

        private void enettsc_OnCallConferenced(object _pCall)
        {
            ENETTSCLib.Call pCall = (ENETTSCLib.Call)_pCall;

            addEventEntry("OnCallConferenced");
            TreeNode tn = searchCallNode("C" + pCall.ID);
            if(tn == null)
            {
                addCallNode(pCall);
                tvLineView.ExpandAll();
            }
            tn = searchCallNode("C" + pCall.ID);
            if(tn != null)
            {
                tn.Text = "C" + pCall.ID + ": Conferenced " + pCall.RemoteContact.DisplayName + " [" + pCall.CurrentNumber + "]";
                tvLineView.ExpandAll();
            }
        }

        private void enettsc_OnCallConnected(object _pCall)
        {
            ENETTSCLib.Call pCall = (ENETTSCLib.Call)_pCall;

            addEventEntry("OnCallConnected");
            TreeNode tn = searchCallNode("C" + pCall.ID);
            if(tn == null)
            {
                addCallNode(pCall);
                tvLineView.ExpandAll();
            }
            tn = searchCallNode("C" + pCall.ID);
            if(tn != null)
            {
                tn.Text = "C" + pCall.ID + ": Connected " + pCall.RemoteContact.DisplayName + " [" + pCall.CurrentNumber + "]";
                tvLineView.ExpandAll();
            }
        }

        private void enettsc_OnCallDestroyed(object _pCall)
        {
            ENETTSCLib.Call pCall = (ENETTSCLib.Call)_pCall;

            cnt++;
            addEventEntry("OnCallDestroyed("+cnt+")");
            removeCallNode("C"+pCall.ID);
        }

        private void enettsc_OnCallDialing(object _pCall)
        {
            ENETTSCLib.Call pCall = (ENETTSCLib.Call)_pCall;
            addEventEntry("OnCallDialing");

            TreeNode tn = searchCallNode("C" + pCall.ID);
            if(tn == null)
            {
                addCallNode(pCall);
                tvLineView.ExpandAll();
            }
            tn = searchCallNode("C" + pCall.ID);
            if(tn != null)
            {
                tn.Text = "C" + pCall.ID + ": Dialing " + pCall.RemoteContact.DisplayName + " [" + pCall.CurrentNumber + "]";
                tvLineView.ExpandAll();
            }
        }

        private void enettsc_OnCallDisconnected(object _pCall)
        {
            ENETTSCLib.Call pCall = (ENETTSCLib.Call)_pCall;
            addEventEntry("OnCallDisconnected");

            TreeNode tn = searchCallNode("C" + pCall.ID);
            if(tn == null)
            {
                addCallNode(pCall);
                tvLineView.ExpandAll();
            }
            tn = searchCallNode("C" + pCall.ID);
            if(tn != null)
            {
                tn.Text = "C" + pCall.ID + ": Disconnected " + pCall.RemoteContact.DisplayName + " [" + pCall.CurrentNumber + "]";
                tvLineView.ExpandAll();
            }
        }

        private void enettsc_OnCallHold(object _pCall)
        {
            ENETTSCLib.Call pCall = (ENETTSCLib.Call)_pCall;
            addEventEntry("OnCallHold");

            TreeNode tn = searchCallNode("C" + pCall.ID);
            if(tn == null)
            {
                addCallNode(pCall);
                tvLineView.ExpandAll();
            }
            tn = searchCallNode("C" + pCall.ID);
            if(tn != null)
            {
                tn.Text = "C" + pCall.ID + ": Hold " + pCall.RemoteContact.DisplayName + " [" + pCall.CurrentNumber + "]";
                tvLineView.ExpandAll();
            }
        }

        private void enettsc_OnCallOffering(object _pCall)
        {
            ENETTSCLib.Call pCall = (ENETTSCLib.Call)_pCall;
            addEventEntry("OnCallOffering");

            TreeNode tn = searchCallNode("C" + pCall.ID);
            if(tn == null)
            {
                addCallNode(pCall);
                tvLineView.ExpandAll();
            }
            tn = searchCallNode("C" + pCall.ID);
            if(tn != null)
            {
                tn.Text = "C" + pCall.ID + ": Offering " + pCall.RemoteContact.DisplayName + " [" + pCall.CurrentNumber + "]";
                tvLineView.ExpandAll();
            }
        }

        private void enettsc_OnCallRingback(object _pCall)
        {
            ENETTSCLib.Call pCall = (ENETTSCLib.Call)_pCall;
            addEventEntry("OnCallRingback");

            TreeNode tn = searchCallNode("C" + pCall.ID);
            if(tn == null)
            {
                addCallNode(pCall);
                tvLineView.ExpandAll();
            }
            tn = searchCallNode("C" + pCall.ID);
            if(tn != null)
            {
                tn.Text = "C" + pCall.ID + ": Ringback " + pCall.RemoteContact.DisplayName + " [" + pCall.CurrentNumber + "]";
                tvLineView.ExpandAll();
            }
        }

        private void enettsc_OnNewUserMessage()
        {
            addEventEntry("OnNewUserMessage");
            int cnt = enettsc.UserMessageCount;
            for(int i=0; i<cnt; i++)
            {
                MessageBox.Show("User-User-Message: " + enettsc.GetNextUserMessage());
            }
        }

        private void enettsc_OnRemotePartyChanged(object _pCall)
        {
            ENETTSCLib.Call pCall = (ENETTSCLib.Call)_pCall;
            addEventEntry("OnRemotePartyChanged");

            TreeNode tn = searchCallNode("C" + pCall.ID);
            
            if(tn == null)
            {
                addCallNode(pCall);
                tvLineView.ExpandAll();
            }
            tn = searchCallNode("C" + pCall.ID);
            if(tn != null)
            {
                tn.Text = "C" + pCall.ID + ": Remoteparty changed " + pCall.RemoteContact.DisplayName + " [" + pCall.CurrentNumber + "]";
                tvLineView.ExpandAll();
            }
        }

		private void enettsc_OnDisconnect()
		{
			addEventEntry("Connection to TAPI-Server lost !");
			// Muss ber einen Delegaten aufgerufen werden, da der Event nicht im selben Thread auftritt,
			// in dem auch die TreeView bearbeitet wird.
			RefreshTreeViewDelegate RTVD = new RefreshTreeViewDelegate(refreshTreeView);
			tvLineView.Invoke(RTVD);
		}

		private void enettsc_OnReconnect()
		{
			addEventEntry("TAPI-Server reconnected.");
			// Muss ber einen Delegaten aufgerufen werden, da der Event nicht im selben Thread auftritt,
			// in dem auch die TreeView bearbeitet wird.
			RefreshTreeViewDelegate RTVD = new RefreshTreeViewDelegate(refreshTreeView);
			tvLineView.Invoke(RTVD);
		}

        private void tvLineView_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if(e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                TreeNode tn = tvLineView.GetNodeAt(e.X, e.Y);
                tvLineView.SelectedNode = tn;

                if(tn is LineTreeNode)
                {
                    cmiMakeCall.Enabled = true;
                    miSwapHold.Enabled = true;
                    miGetActiveCall.Enabled = true;
                    miSendMessage.Enabled = true;
                    miMergeCalls.Enabled = true;

                    cmiHangup.Enabled = false;
                    miAnswerCall.Enabled = false;
                    miRedirectTo.Enabled = false;
                    miUnhold.Enabled = false;
                    miStartCallRecording.Enabled = false;
                }
                else if(tn is CallTreeNode)
                {
                    cmiMakeCall.Enabled = false;
                    miSwapHold.Enabled = false;
                    miGetActiveCall.Enabled = false;
                    miSendMessage.Enabled = false;
                    miMergeCalls.Enabled = false;

                    cmiHangup.Enabled = true;
                    miAnswerCall.Enabled = true;
                    miRedirectTo.Enabled = true;
                    miUnhold.Enabled = true;
                    miStartCallRecording.Enabled = true;
                }
                else
                {
                    cmiMakeCall.Enabled = false;
                    miSwapHold.Enabled = false;
                    miGetActiveCall.Enabled = false;
                    miSendMessage.Enabled = false;
                    miMergeCalls.Enabled = false;

                    cmiHangup.Enabled = false;
                    miAnswerCall.Enabled = false;
                    miRedirectTo.Enabled = false;
                    miUnhold.Enabled = false;
                    miStartCallRecording.Enabled = false;
                }
            }
        }

        private void cmiMakeCall_Click(object sender, System.EventArgs e)
        {
            TreeNode tn = tvLineView.SelectedNode;
            if(tn is LineTreeNode)
            {
                LineTreeNode ltn = (LineTreeNode)tn;
                ENETTSCLib.Line line = ltn.getLine();

                DlgNumberInput dlg = new DlgNumberInput();
                DialogResult res = dlg.ShowDialog();
                if(res == DialogResult.OK)
                {
                    try
                    {
                        line.MakeCall(dlg.Number);
                    }
                    catch(System.Runtime.InteropServices.COMException ex)
                    {
                        MessageBox.Show(ex.Message);
                    }
                }
            }
        }

        private void cmiHangup_Click(object sender, System.EventArgs e)
        {
            TreeNode tn = tvLineView.SelectedNode;
            if(tn is CallTreeNode)
            {
                CallTreeNode ctn = (CallTreeNode)tn;
                ENETTSCLib.Call call = ctn.getCall();
                try
                {
                    call.Hangup();
                }
                catch(System.Runtime.InteropServices.COMException ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void miAnswerCall_Click(object sender, System.EventArgs e)
        {
            TreeNode tn = tvLineView.SelectedNode;
            if(tn is CallTreeNode)
            {
                CallTreeNode ctn = (CallTreeNode)tn;
                ENETTSCLib.Call call = ctn.getCall();
                try
                {
                    call.Answer();
                }
                catch(System.Runtime.InteropServices.COMException ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void miRedirectTo_Click(object sender, System.EventArgs e)
        {
            TreeNode tn = tvLineView.SelectedNode;
            if(tn is CallTreeNode)
            {
                CallTreeNode ctn = (CallTreeNode)tn;
                ENETTSCLib.Call call = ctn.getCall();
                try
                {
                    DlgNumberInput dlg = new DlgNumberInput();
                    DialogResult res = dlg.ShowDialog();
                    if(res == DialogResult.OK)
                    {                    
                        call.RedirectTo(dlg.Number);
                    }
                }
                catch(System.Runtime.InteropServices.COMException ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }        
        }

        private void miUnhold_Click(object sender, System.EventArgs e)
        {
            TreeNode tn = tvLineView.SelectedNode;
            if(tn is CallTreeNode)
            {
                CallTreeNode ctn = (CallTreeNode)tn;
                ENETTSCLib.Call call = ctn.getCall();
                try
                {
                    call.Unhold();
                }
                catch(System.Runtime.InteropServices.COMException ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void miMergeCalls_Click(object sender, System.EventArgs e)
        {
            TreeNode tn = tvLineView.SelectedNode;
            if(tn is LineTreeNode)
            {
                LineTreeNode ltn = (LineTreeNode)tn;
                ENETTSCLib.Line line = ltn.getLine();
                try
                {
                    line.MergeCalls();
                }
                catch(System.Runtime.InteropServices.COMException ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void miStartCallRecording_Click(object sender, System.EventArgs e)
        {
            TreeNode tn = tvLineView.SelectedNode;
            if(tn is CallTreeNode)
            {
                CallTreeNode ctn = (CallTreeNode)tn;
                ENETTSCLib.Call call = ctn.getCall();
                try
                {
                    call.StartCallRecording();
                }
                catch(System.Runtime.InteropServices.COMException ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void miSwapHold_Click(object sender, System.EventArgs e)
        {
            TreeNode tn = tvLineView.SelectedNode;
            if(tn is LineTreeNode)
            {
                LineTreeNode ltn = (LineTreeNode)tn;
                ENETTSCLib.Line line = ltn.getLine();

                try
                {
                    line.SwapHold();
                }
                catch(System.Runtime.InteropServices.COMException ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void miGetActiveCall_Click(object sender, System.EventArgs e)
        {
            TreeNode tn = tvLineView.SelectedNode;
            if(tn is LineTreeNode)
            {
                LineTreeNode ltn = (LineTreeNode)tn;
                ENETTSCLib.Line line = ltn.getLine();

                try
                {
                    if(line.ActiveCall == null)
                    {
                        MessageBox.Show("No Active Call");
                    }
                    else
                    {
                        string tmp = String.Format("Active Call: 0x{0:X8}", line.ActiveCall.ID);                            
                        MessageBox.Show(tmp);
                    }
                }
                catch(System.Runtime.InteropServices.COMException ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void miSendMessage_Click(object sender, System.EventArgs e)
        {
            TreeNode tn = tvLineView.SelectedNode;
            if(tn is LineTreeNode)
            {
                LineTreeNode ltn = (LineTreeNode)tn;
                ENETTSCLib.Line line = ltn.getLine();

                DlgNumberInput dlg = new DlgNumberInput();
                dlg.Text = "Type a Message:";
                DialogResult res = dlg.ShowDialog();
                if(res == DialogResult.OK)
                {
                    try
                    {
                        line.SendMessage(dlg.Number);
                    }
                    catch(System.Runtime.InteropServices.COMException ex)
                    {
                        MessageBox.Show(ex.Message);
                    }
                }
            }
		}
	}
}
