// MFC_ATL_ClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "..\..\COM\COMTools.h"
#include "MFC_ATL_Client.h"
#include "MFC_ATL_ClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define COL_MSG          0

BEGIN_DISPATCH_MAP(CMFC_ATL_ClientDlg, CDialog)
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnCallBusy",           0x01, OnCallBusy,           VT_EMPTY, VTS_DISPATCH )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnCallConnected",      0x02, OnCallConnected,      VT_EMPTY, VTS_DISPATCH )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnCallDestroyed",      0x03, OnCallDestroyed,      VT_EMPTY, VTS_DISPATCH )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnCallDialing",        0x04, OnCallDialing,        VT_EMPTY, VTS_DISPATCH )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnCallDisconnected",   0x05, OnCallDisconnected,   VT_EMPTY, VTS_DISPATCH )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnCallHold",           0x06, OnCallHold,           VT_EMPTY, VTS_DISPATCH )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnCallOffering",       0x07, OnCallOffering,       VT_EMPTY, VTS_DISPATCH )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnCallRingback",       0x08, OnCallRingback,       VT_EMPTY, VTS_DISPATCH )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnRemotePartyChanged", 0x09, OnRemotePartyChanged, VT_EMPTY, VTS_DISPATCH )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnNewUserMessage",     0x0a, OnNewUserMessage,     VT_EMPTY, VTS_DISPATCH ) // currently never fired
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnCallConferenced",    0x0b, OnCallConferenced,    VT_EMPTY, VTS_DISPATCH )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnReconnect",          0x0c, OnReconnect,          VT_EMPTY, VTS_NONE )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnDisconnect",         0x0d, OnDisconnect,         VT_EMPTY, VTS_NONE )
END_DISPATCH_MAP()

BEGIN_INTERFACE_MAP(CMFC_ATL_ClientDlg, CDialog)
	INTERFACE_PART(CMFC_ATL_ClientDlg, DIID__IApplicationEvents, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFC_ATL_ClientDlg dialog
CMFC_ATL_ClientDlg::CMFC_ATL_ClientDlg (CWnd* pParent /*=NULL*/)
	: CDialog(CMFC_ATL_ClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMFC_ATL_ClientDlg)
	//}}AFX_DATA_INIT
	EnableAutomation();
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_dwCookie = 0xfefefefe; // magic value indicates advise isn't active
}

CMFC_ATL_ClientDlg::~CMFC_ATL_ClientDlg()
{
}

void CMFC_ATL_ClientDlg::DoDataExchange (CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMFC_ATL_ClientDlg)
	DDX_Control(pDX, IDC_RBLISTBOX, m_rbListBox);
	DDX_Control(pDX, IDC_RBMESSAGEBOX, m_rbMessageBox);
	DDX_Control(pDX, IDC_USEREG4USER, m_cbUseRegUser);
	DDX_Control(pDX, IDC_USEREG4SERVER, m_cbUseRegServer);
	DDX_Control(pDX, IDC_EDITUSERPASSWD, m_eUserPasswd);
	DDX_Control(pDX, IDC_EDITUSERNAME, m_eUserName);
	DDX_Control(pDX, IDC_EDITSERVERPORT, m_eServerPort);
	DDX_Control(pDX, IDC_EDITSERVERADRESS, m_eServerAddress);
	DDX_Control(pDX, IDC_CALLS, m_lvCalls);
	DDX_Control(pDX, IDC_EDITFN, m_eFromNumber);
	DDX_Control(pDX, IDC_EDITTN, m_eToNumber);
	DDX_Control(pDX, IDC_LINES, m_lbLines);
	DDX_Control(pDX, IDC_EVENTSINK, m_btnAdvise);
	DDX_Control(pDX, IDC_SERVERVER, m_cbServerVer);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMFC_ATL_ClientDlg, CDialog)
	//{{AFX_MSG_MAP(CMFC_ATL_ClientDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RBLISTBOX, OnRblistbox)
	ON_BN_CLICKED(IDC_RBMESSAGEBOX, OnRbmessagebox)
	ON_BN_CLICKED(IDC_USEREG4SERVER, OnUsereg4server)
	ON_BN_CLICKED(IDC_USEREG4USER, OnUsereg4user)
	ON_BN_CLICKED(IDC_BUTTON_DIAL, OnBnDial)
	ON_BN_CLICKED(IDC_BUTTON_SWAPHOLD, OnButtonSwaphold)
	ON_BN_CLICKED(IDC_BUTTON_MERGECALLS, OnBnClickedButtonMergecalls)
	ON_BN_CLICKED(IDC_BUTTON_UNHOLD, OnButtonUnhold)
	ON_BN_CLICKED(IDC_BUTTON_MERGECALL, OnBnClickedButtonMergecall)
	ON_BN_CLICKED(IDC_HANGUP, OnBnClickedHangup)
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(IDC_BUTTON_REDIRECT, OnButtonRedirect)
	ON_CLBN_CHKCHANGE(IDC_LINES, OnLbnChkChangeLines)
	ON_WM_DELETEITEM()
	ON_NOTIFY(LVN_DELETEITEM, IDC_CALLS, OnLvnDeleteitemCalls)
	ON_WM_DESTROY()
	ON_LBN_SELCHANGE(IDC_LINES, OnLbnSelchangeLines)
	ON_BN_CLICKED(IDC_EVENTSINK, OnBnClickedEventsink)
	ON_CBN_SELENDOK(IDC_SERVERVER, OnCbnSelendokServerver)
	ON_BN_CLICKED(IDC_REFRESHLINES, OnBnClickedRefreshlines)
	ON_BN_CLICKED(IDC_ANSWER, OnBnClickedAnswer)
	ON_NOTIFY(NM_RCLICK, IDC_CALLS, OnNMRclickCalls)
	ON_COMMAND(ID_LINE_HANGUP, OnLineHangup)
	ON_COMMAND(ID_LINE_DUMP, OnLineDump)
	ON_BN_CLICKED(IDC_BUTTON_CALLREC, OnBnClickedButtonCallrec)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFC_ATL_ClientDlg message handlers
BOOL CMFC_ATL_ClientDlg::OnInitDialog ()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	m_cbServerVer.SetCurSel(0);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	SetState(ssInitialize); // Preset all controls to their default state

	// prepare Calls ListView
	m_lvCalls.InsertColumn (COL_MSG, _T("Message"), 0, 245);

	return TRUE;  // return TRUE  unless you set the focus to a control
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFC_ATL_ClientDlg::OnPaint () 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CMFC_ATL_ClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMFC_ATL_ClientDlg::OnRblistbox() 
{
}

void CMFC_ATL_ClientDlg::OnRbmessagebox() 
{
}

void CMFC_ATL_ClientDlg::OnUsereg4server() 
{
	SetState(ssNormal); //Update View
}

void CMFC_ATL_ClientDlg::OnUsereg4user() 
{
	SetState(ssNormal); //Update View
}

void CMFC_ATL_ClientDlg::OnCbnSelendokServerver()
{
	USES_CONVERSION;

	const int iCurSel = m_cbServerVer.GetCurSel();
	if (0 > iCurSel)
		return;

	try
	{
		ReleaseApplication();

		CString strServerProID;
		m_cbServerVer.GetLBText(iCurSel, strServerProID);
		if ("NONE" != strServerProID)
		{
			CLSID clsidApplication = CLSID_NULL;
			HRESULT hr = ::IIDFromString(T2COLE(strServerProID), &clsidApplication);
			if (FAILED(hr))
				hr = ::CLSIDFromProgID(T2COLE(strServerProID), &clsidApplication);

			// Create instances
			hr = m_spApp.CreateInstance(clsidApplication);
			if (FAILED(hr))
				_com_issue_error(hr);

			// using ENetTSC registered as SharedComponent
			// wer eine instance mittels CLSID auswaehlt be/ver-hindert den COM Versionierungs ansatz "Redirection using ProgId"!!!
			// Grundvoraussetzung ist natuerlich immer die einhaltung der binaerkompatibilitaet der verwendeten Schnittstellen.
			// BSP: die ENetTSC gibt es in ZWEI Versionen.
			// das heisst es gibt ZWEI CLSID's. Jede version des Application Object hat seine eigene.
			// daraus folgt ALLE Versionen der ENetTSC koennen paralell (SideBySide) installiert werden.
			// eine Anwendung sollte eine instanz standardmaessig immer mittels der VersionIndependentProgID addressieren und NICHT mittels CLSID.
			// FALSCH: m_spApp.CreateInstance (__uuidof(Application)); RICHTIG: m_spApp.CreateInstance ("ENetTSC.Application");
			// somit kann jederzeit die DEFAULT Version ueber die registry konfiguriert werden.
			// HINWEIS: Jede ENetTSC setzt sich bei der installation als DEFAULT, so das immer die zuletzt installierte version als DEFAULT gilt.
			// ACHTUNG:
			// das das ganze hier nicht einfach mit der selektion der gewnschten version aus der ServerVer-Combo funktioniert liegt
			// nicht im verantwortungsbereich des COM Versionierungs ansatzes.
			// Das Versionnierungsverfahren der ESTOS CtiServer legt u.a. fuer jede CtiServer-Version einen neuen Port fest.
			// da aber versionsuebergreifend die selben registry keys zur konfiguration von Server, Port verwendet werden
			// muessen diese von user manuell eingetragen werden.

			// using ENetTSC Registration-Free Activation of COM Components,
			// um diese anwendung beispielhaft fuer "Registration-Free Activation of COM Components" zu praeparieren gehen sie wie folgt vor:
			// nehmen sie die vorgegebene datei "MFC_ATL_Client.exe - Copy.manifest" die sie nach "MFC_ATL_Client.exe.manifest" umbenennen
			// und aktualisieren sie die version in der zeile "type='win32' name='ESTOS.PROCALL.ENetTSCAsm' version='4.0.1.927'" auf den von ihnen verwendeten wert.
			// ODER generieren sie ein Application Manifest indem sie unter Solution->Properties->Linker->Manifest File->Additional Manifest Dependencies
			// den folgenden string eintragen (nicht vergessen die version auf den von ihnen verwendeten wert zu aendern)
			// type='win32' name='ESTOS.PROCALL.ENetTSCAsm' version='4.0.1.927'
			// setzen sie Solution->Properties->Manifest Tool->Input and Output->Embed Manifest = false und compilieren sie neu
			// kopieren sie die dateien "ENetTSC.dll" und "ESTOS.PROCALL.ENetTSCAsm.manifest" in das verzeichnis der Anwendung fertig

			// MIGRATION:
			// um unglcklich codierte anwendungen (verwenden von CLSID statt ProgID) von SDK-Anwendern dennoch migrieren zu knnen
			// besteht die moeglichkeit sich des "TreatAs" RegistryKey's zu bedienen. Mit diesem Notnagel kann eine Aktivierungsanforderung
			// auf eine andere Klasse umgeleitet werden.
			if (!m_cbUseRegServer.GetCheck())
			{
				CString csServerAddress, csServerPort;
				m_eServerAddress.GetWindowText(csServerAddress);
				m_eServerPort.GetWindowText(csServerPort);
				m_spApp->SetServer((LPCTSTR)csServerAddress, _ttoi((LPCTSTR)csServerPort));
			}
			
			if (!m_cbUseRegUser.GetCheck())
			{
				CString csUserName, csUserPasswd;
				m_eUserName.GetWindowText(csUserName);
				m_eUserPasswd.GetWindowText(csUserPasswd);
				m_spApp->SetLogin((LPCTSTR)csUserName, (LPCTSTR)csUserPasswd);
			}

			m_spApp->Connect();
			OnBnClickedRefreshlines();
			m_lvCalls.InsertItem (INT_MAX, _T("Application allocated & connected"));
		}

	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}
}

void CMFC_ATL_ClientDlg::GetTextFromLoginResult (
	ENETTSCLib::LoginResult res,
	CString&                txt)
{

	switch(res)
	{
	case ENETTSCLib::eNETLOGIN_OK:
		txt = "NETLOGIN_OK";
		return;
	case ENETTSCLib::eNETLOGIN_INVALUSERNAME:
		txt = "NETLOGIN_INVALUSERNAME";
		return;
	case ENETTSCLib::eNETLOGIN_INVALIDPASS:
		txt = "NETLOGIN_INVALIDPASS";
		return;
	case ENETTSCLib::eNETLOGIN_NOMOREUSERS	:
		txt = "NETLOGIN_NOMOREUSERS	";
		return;
	case ENETTSCLib::eNETLOGIN_INVALIDVERSION:
		txt = "NETLOGIN_INVALIDVERSION";
		return;
	case ENETTSCLib::eNETLOGIN_COMPUTERNOTENABLED:
		txt = "NETLOGIN_COMPUTERNOTENABLED";
		return;
	case ENETTSCLib::eNETLOGIN_USERNOTENABLED:
		txt = "NETLOGIN_USERNOTENABLED";
		return;
	case ENETTSCLib::eNETLOGIN_INVALIDCOMPUTERNAME:
		txt = "NETLOGIN_INVALIDCOMPUTERNAME";
		return;
	case ENETTSCLib::eNETLOGIN_DOMAINAUTHFAILED:
		txt = "NETLOGIN_DOMAINAUTHFAILED";
		return;
	case ENETTSCLib::eNETLOGIN_MISSINGRIGHTS:
		txt = "NETLOGIN_MISSINGRIGHTS";
		return;
	}
}

void CMFC_ATL_ClientDlg::OnBnDial()
{
	m_lvCalls.DeleteAllItems ();

	const int iCurSel = m_lbLines.GetCurSel ();
	if (0 > iCurSel)
		return;

	CString csToNumber;
	m_eToNumber.GetWindowText(csToNumber);

	try
	{
		ILinePtr spLine(reinterpret_cast < ILine* > (m_lbLines.GetItemDataPtr (iCurSel)));
		spLine->MakeCall((LPCTSTR)csToNumber);
		DumpLine(spLine);

	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}
}

void CMFC_ATL_ClientDlg::SetState (tState aState)
{

	// Enable/disable form controls

	switch (aState)
	{
	case ssInitialize:	// Set initial button states
		m_cbUseRegServer.SetCheck(1);
		m_eServerAddress.SetWindowText(_T(""));
		m_eServerPort.SetWindowText(_T(""));

		m_cbUseRegUser.SetCheck(1);
		m_eUserName.SetWindowText(_T(""));
		m_eUserPasswd.SetWindowText(_T(""));

		CheckDlgButton(IDC_RBLISTBOX, true);

		m_eFromNumber.SetWindowText(_T(""));
		m_eToNumber.SetWindowText(_T(""));

		// recursive call to set the correct enabled-states
		SetState(ssNormal);
		break;

	case ssNormal:	// Normal state, not connected
		// Server and Login data boxes
		m_cbUseRegServer.EnableWindow(true);
		m_eServerAddress.EnableWindow(!m_cbUseRegServer.GetCheck());
		m_eServerPort.EnableWindow(!m_cbUseRegServer.GetCheck());

		m_cbUseRegUser.EnableWindow(true);
		m_eUserName.EnableWindow(!m_cbUseRegUser.GetCheck());
		m_eUserPasswd.EnableWindow(!m_cbUseRegUser.GetCheck());

		m_rbListBox.EnableWindow(false);
		m_rbMessageBox.EnableWindow(false);
		break;

	case ssConnected: // Connected state
		// GroupBoxes
		m_cbUseRegServer.EnableWindow(false);
		m_eServerAddress.EnableWindow(false);
		m_eServerPort.EnableWindow(false);

		m_cbUseRegUser.EnableWindow(false);
		m_eUserName.EnableWindow(false);
		m_eUserPasswd.EnableWindow(false);

		m_rbListBox.EnableWindow(true);
		m_rbMessageBox.EnableWindow(true);
		break;
	}
}

void CMFC_ATL_ClientDlg::OnButtonSwaphold () 
{
	m_lvCalls.DeleteAllItems ();

	const int iCurSel = m_lbLines.GetCurSel ();
	if (0 > iCurSel)
		return;

	try
	{
		ILine* pLine = reinterpret_cast < ILine* > (m_lbLines.GetItemDataPtr (iCurSel));
		pLine->SwapHold ();
		DumpLine(pLine);
	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}
}

void CMFC_ATL_ClientDlg::OnButtonUnhold () 
{
	const int iCurSel = m_lvCalls.GetNextItem (-1, LVNI_ALL | LVNI_SELECTED);
	if (0 > iCurSel)
		return;

	try
	{
		ICallPtr spCall = reinterpret_cast < ICall* > (m_lvCalls.GetItemData (iCurSel));
		spCall->Unhold();

	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}
}

void CMFC_ATL_ClientDlg::OnBnClickedButtonMergecalls()
{
	m_lvCalls.DeleteAllItems ();

	const int iCurSel = m_lbLines.GetCurSel ();
	if (0 > iCurSel)
		return;

	try
	{
		ILine* pLine = reinterpret_cast < ILine* > (m_lbLines.GetItemDataPtr (iCurSel));
		pLine->MergeCalls();
		DumpLine(pLine);
	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}
}

void CMFC_ATL_ClientDlg::OnBnClickedButtonMergecall()
{
	const int iCurSel = m_lvCalls.GetNextItem (-1, LVNI_ALL | LVNI_SELECTED);
	if (0 > iCurSel)
		return;

	try
	{
		ICallPtr spCall = reinterpret_cast < ICall* > (m_lvCalls.GetItemData (iCurSel));
		spCall->MergeCall();

	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}
}

void CMFC_ATL_ClientDlg::OnButtonRedirect()
{
	m_lvCalls.DeleteAllItems ();
	const int iCurSel = m_lbLines.GetCurSel ();
	if (0 > iCurSel)
		return;

	try
	{
		CString strTo;
		GetDlgItemText(IDC_EDITTN, strTo);

		ILine* pLine = reinterpret_cast < ILine* > (m_lbLines.GetItemDataPtr (iCurSel));
		pLine->ActiveCall->RedirectTo (_bstr_t(strTo));
		DumpLine(pLine);

	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}	
}

void CMFC_ATL_ClientDlg::OnBnClickedHangup()
{
	const int iCurSel = m_lbLines.GetCurSel ();
	if (0 > iCurSel)
		return;

	try
	{
		ILine* pLine = reinterpret_cast < ILine* > (m_lbLines.GetItemDataPtr (iCurSel));
		pLine->ActiveCall->Hangup ();
	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}	
}

void CMFC_ATL_ClientDlg::OnLbnChkChangeLines()
{
	const int iCurSel = m_lbLines.GetCurSel ();
	if (0 > iCurSel)
		return;

	int iState = m_lbLines.GetCheck(iCurSel);

	try
	{
		ILine* pLine = reinterpret_cast < ILine* > (m_lbLines.GetItemDataPtr (iCurSel));
		if (0 == iState)
			pLine->Close();

		else if (1 == iState)
			pLine->Open();

	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}
}

void CMFC_ATL_ClientDlg::OnLbnSelchangeLines()
{
	try
	{
		m_lvCalls.DeleteAllItems ();
		const int iCurSel = m_lbLines.GetCurSel ();
		if (0 <= iCurSel)
			DumpLine(reinterpret_cast < ILine* > (m_lbLines.GetItemDataPtr (iCurSel)));

	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}
}

// ms-help://MS.VSCC.v80/MS.MSDN.vAug06.en/shellcc/platform/commctls/listboxes/listboxreference/listboxmessages/wm_deleteitem.htm
void CMFC_ATL_ClientDlg::OnDeleteItem(int nIDCtl, LPDELETEITEMSTRUCT lpDeleteItemStruct)
{
	if (IDC_LINES == nIDCtl)
	{
		_ASSERT(ODT_LISTBOX == lpDeleteItemStruct->CtlType);
		ILine* pLine = reinterpret_cast < ILine* > (m_lbLines.GetItemDataPtr (lpDeleteItemStruct->itemID));

		// vor dem Close (stop monitoring) koennte man vorsichtshalber fragen ob die Line ueberhaupt monitored wird
		// da das Line object KEINE moeglichkeit bietet den status, monitored oder nicht, abzufragen muesste man hier
		// auf den Checked status des ListboxItem's zurueckgreifen
		HRESULT hr = pLine->raw_Close();
		pLine->Release();
	}

	__super::OnDeleteItem(nIDCtl, lpDeleteItemStruct);
}

void CMFC_ATL_ClientDlg::OnLvnDeleteitemCalls (NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast < LPNMLISTVIEW >(pNMHDR);

	LPUNKNOWN pUnk = reinterpret_cast < LPUNKNOWN > (pNMLV->lParam);
	if (NULL != pUnk)
		pUnk->Release();

	*pResult = 0;
}

void CMFC_ATL_ClientDlg::OnDestroy()
{
	Unadvise();
	ReleaseApplication();
	__super::OnDestroy();
}

void CMFC_ATL_ClientDlg::OnBnClickedAnswer ()
{
	const int iCurSel = m_lvCalls.GetNextItem (-1, LVNI_ALL | LVNI_SELECTED);
	if (0 > iCurSel)
		return;

	try
	{
		ICallPtr spCall = reinterpret_cast < ICall* > (m_lvCalls.GetItemData (iCurSel));
		spCall->Answer ();

	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}	
}

void CMFC_ATL_ClientDlg::OnBnClickedEventsink ()
{
	if (m_btnAdvise.GetCheck())
	{
		if (m_spApp)
		{
			::AfxConnectionAdvise(m_spApp.GetInterfacePtr(), DIID__IApplicationEvents, GetIDispatch(FALSE), FALSE, &m_dwCookie);
			m_cbServerVer.EnableWindow (false);
		}

	}
	else
	{
		Unadvise();
	}
}

void CMFC_ATL_ClientDlg::OnBnClickedRefreshlines ()
{
	if (m_spApp)
	{
		m_lbLines.ResetContent();

		_bstr_t bstrFirstNumber;
		try { bstrFirstNumber = m_spApp->FirstLine->Number; } catch (const _com_error& e) { e; }

		_bstr_t bstrSecondNumber;
		try { bstrSecondNumber = m_spApp->SecondLine->Number; } catch (const _com_error& e) { e; }

		ILinesPtr spLines(m_spApp->Lines);
		for (int iIndex = spLines->Count; 0 < iIndex; iIndex--)
		{
			ILinePtr spLine(spLines->GetItem(iIndex));
			_bstr_t bstrNumber(spLine->Number);
			if (bstrNumber == bstrFirstNumber)
				bstrNumber += L" (F)";

			else if (bstrNumber == bstrSecondNumber)
				bstrNumber += L" (S)";

			const int iLB = m_lbLines.AddString(bstrNumber);
			m_lbLines.SetItemDataPtr (iLB, spLine.Detach());

			// es gibt im prinzip KEINE moeglichkeit herauszufinden ob eine Line geoeffnet ist
			// m_lbLines.SetCheck(iLB, TRUE/FALSE);
		}
	}
}

HRESULT CMFC_ATL_ClientDlg::ReleaseApplication ()
{
	if (m_spApp)
	{
		Unadvise();

		// Destroy Application object to disconnect
		m_spApp.Release();
		m_lvCalls.InsertItem (INT_MAX, _T("Application freed"));
		SetState(ssNormal);
	}

	return NOERROR;
}

void CMFC_ATL_ClientDlg::DumpCall (
	LPCTSTR    szEvent,
	LPUNKNOWN  pCall)
{
	try
	{
		ENETTSCLib::ICallPtr spCall(pCall);
		CString strMsg;
		strMsg.Format(_T("%s State: %s"), szEvent, CMFC_ATL_ClientDlg::FormatCallState(spCall->State));

		spCall.AddRef (); // this reference will be freed in CMFC_ATL_ClientDlg::OnLvnDeleteitemCalls()
		m_lvCalls.InsertItem (LVIF_TEXT | LVIF_PARAM, INT_MAX, strMsg, 0, 0, 0, (LPARAM) spCall.GetInterfacePtr ());

		// DumpLine(spCall->ParentLine);
        DumpRemoteContact(IRemoteContactPtr(spCall->RemoteContact));

	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}
}

void CMFC_ATL_ClientDlg::DumpLine (ILine* pLine)
{
	ILinePtr spLine(pLine);
	long lumc = spLine->Application->UserMessageCount;

	ICallsPtr spCalls(spLine->Calls);
	const int iNoOfCalls = spCalls->Count;
	CString strMsg;
	strMsg.Format(_T("currently %d active calls OnLine(%#.8x)"), iNoOfCalls, spLine->ID);
	m_lvCalls.InsertItem (INT_MAX, strMsg);

	ICallPtr spActiveCall;
	spLine->get_ActiveCall(&spActiveCall);
	for (int iCall = 1; iNoOfCalls >= iCall; iCall++)
	{
		ICallPtr spCall(spCalls->GetItem(iCall));
        DumpRemoteContact(IRemoteContactPtr(spCall->RemoteContact));
		strMsg.Format(_T("%d.) -> %ls, %s"), iCall, spCall->CurrentNumber.GetBSTR(), CMFC_ATL_ClientDlg::FormatCallState(spCall->State));

		if (spActiveCall == spCall)
			strMsg += " (A)";

		m_lvCalls.InsertItem (LVIF_TEXT | LVIF_PARAM, INT_MAX, strMsg, 0, 0, 0, (LPARAM) spCall.Detach());
	}
}

#define DUMP_RCFIELD(name) ATLTRACE2(atlTraceGeneral, 4, _T("  ") _T(#name) _T(":    %ls\n"), (BSTR) spRC->name)
void CMFC_ATL_ClientDlg::DumpRemoteContact (IRemoteContact* pRemoteContact)
{
    IRemoteContactPtr spRC(pRemoteContact);
    DUMP_RCFIELD(CurrentNumberSC);
    DUMP_RCFIELD(EntryIDDB);
    DUMP_RCFIELD(EntryIDStore);
    DUMP_RCFIELD(Custom0);
    DUMP_RCFIELD(Custom1);
    DUMP_RCFIELD(Custom2);
    DUMP_RCFIELD(Custom3);
    DUMP_RCFIELD(Custom4);
}

BOOL CMFC_ATL_ClientDlg::Unadvise ()
{
	m_cbServerVer.EnableWindow (true);
	if (!m_spApp)
		return true;

	BOOL bRetC = FALSE;
	if (0xfefefefe != m_dwCookie)
		bRetC = ::AfxConnectionUnadvise(m_spApp.GetInterfacePtr (), DIID__IApplicationEvents, GetIDispatch(FALSE), FALSE, m_dwCookie);

	m_dwCookie = 0xfefefefe;
	return bRetC;
}

/*static*/ TCHAR* CMFC_ATL_ClientDlg::FormatCallState (Callstate eCallState)
{
	static TCHAR* rgState[] = {
		_T("csNull"),
		_T("csDialing"),
		_T("csBusy"),
		_T("csRingback"),
		_T("csOffering"),
		_T("csConnected"),
		_T("csHold"),
		_T("csDisconnected"),
		_T("csDestroyed"),
		_T("csConferenced"),
		_T("csRemotePartyChanged")
		};

	return rgState[eCallState];
}

// _IApplicationEvents Implementation
void CMFC_ATL_ClientDlg::OnCallBusy (LPDISPATCH pCall)
{
	DumpCall(_T("OnCallBusy"), pCall);
}

void CMFC_ATL_ClientDlg::OnCallConnected (LPDISPATCH pCall)
{
	DumpCall(_T("OnCallConnected"), pCall);
}

void CMFC_ATL_ClientDlg::OnCallDestroyed (LPDISPATCH pCall)
{
	DumpCall(_T("OnCallDestroyed"), pCall);
}

void CMFC_ATL_ClientDlg::OnCallDialing (LPDISPATCH pCall)
{
	DumpCall(_T("OnCallDialing"), pCall);
}

void CMFC_ATL_ClientDlg::OnCallDisconnected (LPDISPATCH pCall)
{
	DumpCall(_T("OnCallDisconnected"), pCall);
}

void CMFC_ATL_ClientDlg::OnCallHold (LPDISPATCH pCall)
{
	DumpCall(_T("OnCallHold"), pCall);
}

void CMFC_ATL_ClientDlg::OnCallOffering (LPDISPATCH pCall)
{
	DumpCall(_T("OnCallOffering"), pCall);
}

void CMFC_ATL_ClientDlg::OnCallRingback (LPDISPATCH pCall)
{
	DumpCall(_T("OnCallRingback"), pCall);
}

void CMFC_ATL_ClientDlg::OnRemotePartyChanged (LPDISPATCH pCall)
{
	DumpCall(_T("OnRemotePartyChanged"), pCall);
}

// currently never fired
void CMFC_ATL_ClientDlg::OnNewUserMessage (LPDISPATCH pCall)
{
	DumpCall(_T("OnNewUserMessage"), pCall);
}

void CMFC_ATL_ClientDlg::OnCallConferenced (LPDISPATCH pCall)
{
	DumpCall(_T("OnCallConferenced"), pCall);
}

void CMFC_ATL_ClientDlg::OnDisconnect (void)
{
	m_lvCalls.InsertItem (INT_MAX, _T("Connection to UCServer lost !"));
}

void CMFC_ATL_ClientDlg::OnReconnect (void)
{
	m_lvCalls.InsertItem (INT_MAX, _T("UCServer reconnected."));
}

void CMFC_ATL_ClientDlg::OnNMRclickCalls (NMHDR* pNMHDR, LRESULT* pResult)
{
	*pResult = 0;

	CPoint ptCursor;
	int iIndex = -1;
	if (::GetCursorPos(&ptCursor))
	{
		CPoint ptClient(ptCursor);
		m_lvCalls.ScreenToClient(&ptClient);

		UINT uiFlags = 0;
		iIndex = m_lvCalls.HitTest (ptClient, &uiFlags);
	}

	if (-1 == iIndex)
		return;

	CMenu mnuContext;
	ICallPtr spCall = reinterpret_cast < ICall* > (m_lvCalls.GetItemData (iIndex));
	if (spCall)
		mnuContext.LoadMenu (IDR_LINE);

	if (mnuContext.m_hMenu)
		mnuContext.GetSubMenu(0)->TrackPopupMenu (TPM_LEFTALIGN | TPM_LEFTBUTTON, ptCursor.x, ptCursor.y, this);
}

void CMFC_ATL_ClientDlg::OnLineHangup ()
{
	const int iCurSel = m_lvCalls.GetNextItem (-1, LVNI_ALL | LVNI_SELECTED);
	if (0 > iCurSel)
		return;

	try
	{
		ICallPtr spCall = reinterpret_cast < ICall* > (m_lvCalls.GetItemData (iCurSel));
		spCall->Hangup ();

	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}	
}

void CMFC_ATL_ClientDlg::OnLineDump()
{
	const int iCurSel = m_lvCalls.GetNextItem (-1, LVNI_ALL | LVNI_SELECTED);
	if (0 > iCurSel)
		return;

	DumpCall(_T("from Command"), (LPUNKNOWN) m_lvCalls.GetItemData (iCurSel));
}

void CMFC_ATL_ClientDlg::OnBnClickedButtonCallrec()
{
	const int iCurSel = m_lvCalls.GetNextItem (-1, LVNI_ALL | LVNI_SELECTED);
	if (0 > iCurSel)
		return;

	try
	{
		ICallPtr spCall = reinterpret_cast < ICall* > (m_lvCalls.GetItemData (iCurSel));
		spCall->StartCallRecording();

	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FORMATMESSAGEFROMMODULE(e));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}	
}
