// MFC_ATL_ClientDlg.h : header file
//

#if !defined(AFX_MFC_ATL_CLIENTDLG_H__E6945F65_CAD1_4B97_A3AE_53D4840D4FC9__INCLUDED_)
#define AFX_MFC_ATL_CLIENTDLG_H__E6945F65_CAD1_4B97_A3AE_53D4840D4FC9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "afxcmn.h"

/////////////////////////////////////////////////////////////////////////////
// CMFC_ATL_ClientDlg dialog
class CMFC_ATL_ClientDlg :
	public CDialog
{
// Construction
public:
	CMFC_ATL_ClientDlg(CWnd* pParent = NULL);	// standard constructor
	~CMFC_ATL_ClientDlg();						// standard denstructor
	static TCHAR* FormatCallState (Callstate eCallState);

// Dialog Data
	//{{AFX_DATA(CMFC_ATL_ClientDlg)
	enum { IDD = IDD_MFC_ATL_CLIENT_DIALOG };
	CButton	      m_rbListBox;
	CButton	      m_rbMessageBox;
	CButton	      m_cbUseRegUser;
	CButton	      m_cbUseRegServer;
	CEdit	      m_eUserPasswd;
	CEdit	      m_eUserName;
	CEdit	      m_eServerPort;
	CEdit	      m_eServerAddress;
	CListCtrl     m_lvCalls;
	CEdit         m_eFromNumber;
	CEdit         m_eToNumber;
	CCheckListBox m_lbLines;
	CButton       m_btnAdvise;
	CComboBox     m_cbServerVer;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMFC_ATL_ClientDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CMFC_ATL_ClientDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCmdinit();
	afx_msg void OnRblistbox();
	afx_msg void OnRbmessagebox();
	afx_msg void OnUsereg4server();
	afx_msg void OnUsereg4user();
	afx_msg void OnBnDial();
	afx_msg void OnButtonSwaphold();
	afx_msg void OnBnClickedButtonMergecalls();
	afx_msg void OnButtonUnhold();
	afx_msg void OnButtonRedirect();
	afx_msg void OnLbnChkChangeLines();
	afx_msg void OnDeleteItem(int nIDCtl, LPDELETEITEMSTRUCT lpDeleteItemStruct);
	afx_msg void OnLvnDeleteitemCalls(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDestroy();
	afx_msg void OnLbnSelchangeLines();
	afx_msg void OnBnClickedHangup();
	afx_msg void OnBnClickedEventsink();
	afx_msg void OnBnClickedRefreshlines();
	afx_msg void OnBnClickedAnswer();
	afx_msg void OnCbnSelendokServerver();
	afx_msg void OnNMRclickCalls(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLineHangup();
	afx_msg void OnLineDump();
	afx_msg void OnBnClickedButtonMergecall();
	afx_msg void OnBnClickedButtonCallrec();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	DECLARE_INTERFACE_MAP()
	DECLARE_DISPATCH_MAP()
	void OnCallBusy           (LPDISPATCH pCall);
	void OnCallConnected      (LPDISPATCH pCall);
	void OnCallDestroyed      (LPDISPATCH pCall);
	void OnCallDialing        (LPDISPATCH pCall);
	void OnCallDisconnected   (LPDISPATCH pCall);
	void OnCallHold           (LPDISPATCH pCall);
	void OnCallOffering       (LPDISPATCH pCall);
	void OnCallRingback       (LPDISPATCH pCall);
	void OnRemotePartyChanged (LPDISPATCH pCall);
	void OnNewUserMessage     (LPDISPATCH pCall);
	void OnCallConferenced    (LPDISPATCH pCall);
	void OnDisconnect         (void);
	void OnReconnect          (void);

private:
	typedef enum {
		ssInitialize = 1,
		ssNormal,
		ssConnected
	} tState;
	IApplicationPtr m_spApp;
	DWORD           m_dwCookie;
	HICON           m_hIcon;

	void    SetState               (tState aState);
	void    GetTextFromLoginResult (ENETTSCLib::LoginResult res, CString& txt);
	HRESULT ReleaseApplication     ();
	BOOL    Unadvise               ();
	void    DumpCall               (LPCTSTR szEvent, LPUNKNOWN pCall);
	void    DumpLine               (ILine* pLine);
	void    DumpRemoteContact      (IRemoteContact* pRemoteContact);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MFC_ATL_CLIENTDLG_H__E6945F65_CAD1_4B97_A3AE_53D4840D4FC9__INCLUDED_)
