// AccountNewHandler.h : Declaration of the CAccountNewHandler

#pragma once
#include "resource.h"       // main symbols
#include "ECrmAddIn.h"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

// CAccountNewHandler
class ATL_NO_VTABLE CAccountNewHandler :
	  public CComObjectRootEx<CComSingleThreadModel>
	, public CComCoClass<CAccountNewHandler, &CLSID_AccountNewHandler>
	, public ECtiClientLib::IClientAddIn
	, public IDispatchImpl < ECtiClientLib::IContactNewHandler, &__uuidof(ECtiClientLib::IContactNewHandler) >
{
public:
	DECLARE_REGISTRY_RESOURCEID(IDR_ACCOUNTNEWHANDLER)

	BEGIN_COM_MAP(CAccountNewHandler)
		COM_INTERFACE_ENTRY(ECtiClientLib::IClientAddIn)
		COM_INTERFACE_ENTRY(ECtiClientLib::IContactNewHandler)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	// IClientAddIn implementation
	STDMETHOD(raw_GetAbout) (/*out*/ BSTR* pbstrAbout, /*out*/ BSTR* pbstrInfo);
	STDMETHOD(raw_OnLoad) (/*in*/ IDispatch* pClientApplication) { return E_NOTIMPL; }
	STDMETHOD(raw_OnUnload) () { return E_NOTIMPL; }

	// IContactNewHandler interface
	STDMETHOD(raw_OnContactNewRequest) (
		/*[in]*/  long       lCookie,
		/*[in]*/  IDispatch* pContact,
		/*[out, retval]*/ VARIANT* pvarName);
	STDMETHOD(raw_QueryOptions) (
		/*[in]*/ long lCookie,
		/*[out,retval]*/ long * plOptions) { return E_NOTIMPL; }
	STDMETHOD(raw_IsContactFieldAvailable) (
		/*[in]*/ long lCookie,
		/*[in]*/ long lPropertyTag,
		/*[out,retval]*/ long* pbRetC);
	STDMETHOD(raw_OnContactNewExecute) (
		/*[in]*/ long       lCookie,
		/*[in]*/ BSTR       bstrFolderID,
		/*[in]*/ IDispatch* pContact);
	STDMETHOD(raw_OnContactNewChooseFolder) (
		/*[in]*/ long lCookie,
		/*[in]*/ long lParent,
		/*[in]*/ IDispatch* pContact,
		/*[out,retval]*/ VARIANT* pvarFolderID) { return E_NOTIMPL; }
	STDMETHOD(raw_GetDefaultLocationFromType) (
		/*[in]*/ long lCookie,
		/*[in]*/ long lFolderType,
		/*[out]*/ BSTR* pbstrFolderStoreID,
		/*[out]*/ BSTR* pbstrFolderEntryID) { return E_NOTIMPL; }
	STDMETHOD(raw_GetDisplayNamesFromIDs) (
		/*[in]*/ long lCookie,
		/*[in]*/ BSTR bstrFolderStoreID,
		/*[in]*/ BSTR bstrFolderEntryID,
		/*[out]*/ BSTR* pbstrStoreName,
		/*[out]*/ BSTR* pbstrFolderName) { return E_NOTIMPL; }
	STDMETHOD(raw_OnContactOpen) (
		/*[in]*/ long lCookie,
		/*[in]*/ IDispatch * pContact) { return E_NOTIMPL; }
};

OBJECT_ENTRY_AUTO(__uuidof(AccountNewHandler), CAccountNewHandler)
