#pragma once
#include "resource.h"       // main symbols
#include "ECrmAddIn.h"

class ATL_NO_VTABLE CContactNewHandler :
	  public CComObjectRootEx < CComSingleThreadModel >
	, public CComCoClass < CContactNewHandler, &CLSID_ContactNewHandler >
	, public ECtiClientLib::IClientAddIn
	, public IDispatchImpl < ECtiClientLib::IContactNewHandler, &__uuidof(ECtiClientLib::IContactNewHandler) >
{
public:
	DECLARE_REGISTRY_RESOURCEID(IDR_CONTACTNEWHANDLER)

	BEGIN_COM_MAP(CContactNewHandler)
		COM_INTERFACE_ENTRY(ECtiClientLib::IClientAddIn)
		COM_INTERFACE_ENTRY(ECtiClientLib::IContactNewHandler)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	// IClientAddIn implementation
	STDMETHOD(raw_GetAbout) (/*out*/ BSTR* pbstrAbout, /*out*/ BSTR* pbstrInfo);
	STDMETHOD(raw_OnLoad) (/*in*/ IDispatch* pClientApplication) { return E_NOTIMPL; }
	STDMETHOD(raw_OnUnload) () { return E_NOTIMPL; }

	// IContactNewHandler interface
	STDMETHOD(raw_OnContactNewRequest) (
		/*[in]*/  long       lCookie,
		/*[in]*/  IDispatch* pContact,
		/*[out, retval]*/ VARIANT* pvarName);
	STDMETHOD(raw_QueryOptions) (
		/*[in]*/ long lCookie,
		/*[out,retval]*/ long * plOptions) { return E_NOTIMPL; }
	STDMETHOD(raw_IsContactFieldAvailable) (
		/*[in]*/ long lCookie,
		/*[in]*/ long lPropertyTag,
		/*[out,retval]*/ long* pbRetC);
	STDMETHOD(raw_OnContactNewExecute) (
		/*[in]*/ long       lCookie,
		/*[in]*/ BSTR       bstrFolderID,
		/*[in]*/ IDispatch* pContact);
	STDMETHOD(raw_OnContactNewChooseFolder) (
		/*[in]*/ long lCookie,
		/*[in]*/ long lParent,
		/*[in]*/ IDispatch* pContact,
		/*[out,retval]*/ VARIANT* pvarFolderID) { return E_NOTIMPL; }
	STDMETHOD(raw_GetDefaultLocationFromType) (
		/*[in]*/ long lCookie,
		/*[in]*/ long lFolderType,
		/*[out]*/ BSTR* pbstrFolderStoreID,
		/*[out]*/ BSTR* pbstrFolderEntryID) { return E_NOTIMPL; }
	STDMETHOD(raw_GetDisplayNamesFromIDs) (
		/*[in]*/ long lCookie,
		/*[in]*/ BSTR bstrFolderStoreID,
		/*[in]*/ BSTR bstrFolderEntryID,
		/*[out]*/ BSTR* pbstrStoreName,
		/*[out]*/ BSTR* pbstrFolderName) { return E_NOTIMPL; }
	STDMETHOD(raw_OnContactOpen) (
		/*[in]*/ long lCookie,
		/*[in]*/ IDispatch * pContact) { return E_NOTIMPL; }
};

OBJECT_ENTRY_AUTO(__uuidof(ContactNewHandler), CContactNewHandler)
