/*
 * CAUTION!
 * This Version is part of the ProCall-Product Release. (not only sample-part of the SDK Release)
 *
 * mit diesem set stellen fuer CWE relevante functionen bereit.
 * CWE == ConversationWindowExtensions.
 * Diese functions werden per script-tag eingebunden und stellen kein module dar.
 * Wir verzichten bewust auf komplexitaet und vermeiden abhaengigkeiten.
 */
const ROUTE_HOST = "/host/"; // estos\etapimonitor\hostAPIHandler.cpp(7)
var nUnique = 0;
var gnRequestedHeight = 0;
function createRequestID() {
	/*
	* warum haben/brauchen wir hier NICHT den HeckMeck mit der Systemweit eindeutigen ID?
	* Dieses Modul ist eindeutig weil durch den Client ausgeliefert und kann somit nicht
	* mehrfach, in unterschiedlichen versionen, geladen sein.
	* siehe: estos-procall-client\index.js(5), createRequestID()
	*
	* Hinweise:
	* 1.) Mit einem Refresh (F5) wird dieser zaehler zurueckgesetzt (logisch).
	* Der CHostAPIHandler inkl. seiner baseclasses (CAPIHandlerBase, CAPIHandlerBase) aktuell nicht.
	* ergo kann es beim mapping (CAPIHandlerBase::m_mapRequestID) zu duplikaten kommen. :-(
	*/
	nUnique += 1;
	return nUnique.toString();
}
function initObjectLayout(nHeight) {
	gnRequestedHeight = nHeight;
	sendRequestNewObjectLayout(nHeight);
}
function requestNewObjectLayout() {
	/*
	 * Diese function ist der ideale kandidat fuer eine (eigene) ApplicationLibrary.
	 * Als simple helper-function innerhalb der mpcapi.js ist sie schon zu speziell/komplex.
	 */
	// der erste/initiale request MUSS garantiert sein. wir erkennen das am 0 == gnRequestedHeight
	// hat natuerlich den haken das die hoehe niemals 0 sein kann (end-los-schleife)
	if (5 >= Math.abs(document.body.scrollHeight - gnRequestedHeight))
		return;

	gnRequestedHeight = document.body.scrollHeight;
	sendRequestNewObjectLayout(gnRequestedHeight);
}
function sendRequestNewObjectLayout(nHeight) {
	const arg = {
		// die: sRequestID ist evtl. unuetz kompliziert.
		// aber der estos\etapimonitor\APIHandlerBase.cpp(93), CAPIHandlerBase::OnWebMessage()
		// erzwingt dieses feld um sicher-zu-stellen das eine antwort geroutet werden kann.
		sRequestID: createRequestID(),
		operationName: ROUTE_HOST + "requestNewObjectLayout",
		body: {
			marginLeft: 0,
			marginTop: 0,
			marginRight: 0,
			marginBottom: 0,
			scrollHeight: nHeight
		}
	};
	window.chrome.webview.postMessage(arg);
}
function onHostMessage(arg) {
	/*
	 * WebView2 (Chrome) bietet nur EINEN einsprung-punkt! d.H.
	 * 1.) ALLE unsere Hosts (CWebViewHost, CHostContactDetails, ...) muessen ueber ein uebergreifenden NamesSchema
	 * verfuegen so das eine Messsage EINDEUTIG zugeordnet werden kann!
	 * 2.) we provide more then one module using a subscription to `window.chrome.webview.addEventListener('message', onHostMessage)`
	 * so we have to test/verify applications which uses all of them simultanously, e.g. cweapi.js AND mpcapi.js
	 */
	try {
		// siehe: estos\etapimonitor\ENetCtiClientConnection.cpp(4596)
		if (99999 === arg.data.invokeID && "asnCtiNotifyLineCallInformation" === arg.data.operationName) {
			let oAsnCallInformationArgument = arg.data.argument;
		}

		// siehe: estos\etapimonitor\ENetCtiClientConnection.cpp(4637)
		else if (99999 === arg.data.invokeID && "asnAVNewCall" === arg.data.operationName) {
			let oAsnAVNewCallArgument = arg.data.argument;
		}

		/*
		 * wir vermeiden aktuell das ermitteln der BPIInformation aus generischen Asn... methoden.
		 * Begruendung: Aufwand!
		 * wir muessten uns hier explizit fuer ALLE moeglichen channels subscriben.
		 * wir muessten snapshot methoden fuer ALLE moeglichen channels implementieren ...
		 *
		 * siehe: estos\etapimonitor\EClientCallInformation.cpp(164)
		 */
		else if (99999 === arg.data.invokeID && "localBPIInformation" === arg.data.operationName) {
			/*
			* Hinweise:
			* Der Host garantiert keine aenderung als Grundlage fuer ein Event.
			* Der Aufruf von requestNewObjectLayout() fuehrt unbedingt zu einem onHostMessage().
			* Es ist zu garantieren das man hier keine end-los-schleife verbaut.
			* onHostMessage() -> requestNewObjectLayout() -> und wieder von vorne ...
			*
			* Wir brauchen ein einfaches & sicheres verfahren!
			* Einfach:
			* Wir merken uns, mit einem requestNewObjectLayout(), die angeforderte hoehe in der globalen variable: gnRequestedHeight (soll)
			* Mit der nachfolgenden onHostMessage() hat der container/layouter die geforderte groesse bereits bereitgestellt.
			* Die rekursion in requestNewObjectLayout() wird unterbrochen sobald `document.body.scrollHeight` (ist) und `gnRequestedHeight` (soll) angeglichen sind.
			* Sicher: (Caution)
			* eine fehlerhafte logik im umgang mit gnRequestedHeight fuehrt zu einer end-los-schleife und damit totalausfall.
			*/

			let oLocalBPIInformationArgument = arg.data.argument;
			console.assert("localBPIInformationArgument" === oLocalBPIInformationArgument._type, "wrong argument type");
			console.log("oLocalBPIInformationArgument:", oLocalBPIInformationArgument);

			// get priority Business-Contact
			// const oPriorityInformation = getPriorityBPIInformation(oLocalBPIInformationArgument);
		}
	} catch (e) {
	}
}
function initCWE(nHeight, cbHostMessage) {
	/*
	 * to run/initialize this module call one of the following:
	 * - initCWE(), setup event handler
	 * - initObjectLayout(), setup only requested height
	 *   e.g. initObjectLayout(document.body.scrollHeight)
	 */
	window.chrome.webview.addEventListener('message', cbHostMessage);
	initObjectLayout(nHeight);
}
window.addEventListener("load", () => {
	try {
		/*
		* wir sparen uns explizite snapShot methoden indem wir definieren dass:
		* nach einem requestNewObjectLayout() bzw. OnDocumentCompleted() ein
		* "localBPIInformation" event gefeuert wird!
		* Hinweis:
		* Es ist zu garantieren das man hier keine end-los-schleife verbaut.
		* onHostMessage() -> requestNewObjectLayout() -> und wieder von vorne ...
				initObjectLayout(document.body.scrollHeight);
		*/
	} catch (e) {
	}
});

/*
 * ab hier kommt alles was mit der "oLocalBPIInformationArgument" struktur zusammenhaengt.
 */
function removeProtocol(sUrl) {
	if ("string" !== typeof sUrl) return "";
	const iIndexOf = sUrl.indexOf(":");
	if (0 > iIndexOf) return sUrl; // kein protocol-prefix
	if (sUrl.length - 1 === iIndexOf) return ""; // nur protocol-prefix
	if (iIndexOf >= 0 && sUrl.length >= 2) return sUrl.substring(iIndexOf + 1);
	return "";
}
function getPrioritySipUri(oContact) {
	const sSIPAddress = removeProtocol(oContact.u8sSIPAddress);
	if (sSIPAddress.length) return sSIPAddress;

	const priorityEMail = getPriorityEMail(oContact);
	if (priorityEMail.length) return priorityEMail;

	return "";
}
function getPriorityEMail(oContact) {
	const sEMail = removeProtocol(oContact.u8sEMail);
	if (sEMail.length) return sEMail;

	const sEMail2 = removeProtocol(oContact.u8sEMail2);
	if (sEMail2.length) return sEMail2;

	const sEMail3 = removeProtocol(oContact.u8sEMail3);
	if (sEMail3.length) return sEMail3;

	return "";
}
function getPriorityPhone(oContact) {
/*
 * diese function ist angelehnt an: ENetDatabaseContactPhoneNumberFields
 * einschraenkung: wir hoeren bei CarTelephoneNumber auf ...
 * estos\common\libs\ETool\ENetDatabaseContact.cpp(45)
 */
	if (oContact.u8sPhoneBusiness.length) return oContact.u8sPhoneBusiness;
	if (oContact.u8sPhoneBusiness2.length) return oContact.u8sPhoneBusiness2;
	if (oContact.u8sCompanyMainTelephoneNumber.length) return oContact.u8sCompanyMainTelephoneNumber;
	if (oContact.u8sAssistantTelephoneNumber.length) return oContact.u8sAssistantTelephoneNumber;
	if (oContact.u8sPhoneHome.length) return oContact.u8sPhoneHome;
	if (oContact.u8sPhoneHome2.length) return oContact.u8sPhoneHome2;
	if (oContact.u8sPrimaryTelephoneNumber.length) return oContact.u8sPrimaryTelephoneNumber;
	if (oContact.u8sPhoneMobile.length) return oContact.u8sPhoneMobile;

	return "";
}
function getPriorityContact(oLocalBPIInformationArgument) {
/*
* es handelt sich um eine rueckfrage aus der zentrale/kollegen
* die Business-relevante information ist der "HoldContact" der den kunden repraesentiert
*/
	if (oLocalBPIInformationArgument.HoldContact.bValid) return oLocalBPIInformationArgument.HoldContact;

	return oLocalBPIInformationArgument.RemoteContact
}
function getPriorityBPIInformation(oLocalBPIInformationArgument) {
	const oRetC = {
			telUri: "",
			sipUri: "",
			mailtoUri: ""
		};

	// estos\common\libs\ETool\ENetDatabaseContact.cpp(366), ENetDatabaseContact::IsValid()
	const oContact = getPriorityContact(oLocalBPIInformationArgument);
	oRetC.sipUri = getPrioritySipUri(oContact);
	oRetC.mailtoUri = getPriorityEMail(oContact);

	if (oLocalBPIInformationArgument.HoldContact.bValid)
		oRetC.telUri = oLocalBPIInformationArgument.HoldNumberSC;
	else
		oRetC.telUri = oLocalBPIInformationArgument.RemoteNumberSC;

	return oRetC;
}

/*
 * ab hier kommt alles was mit dem JavaScript-Object "Contact" zusammenhaengt.
 *
 * task-psi: mergen => HelloCWE, cherry-pick => develop
 * [JavaScript Object Constructors](https://www.w3schools.com/JS/js_object_constructors.asp)
 */
function Contact(oContact) {
	this.oContact = oContact;
	this.customFields = {};
	if (this.oContact.customFields) // build set/dictionary from array and throw empty values
		this.oContact.customFields.forEach((value, index, array) => { if (value.value.length) this.customFields[value.key] = value.value });
	this.getContactURL0 = function () { return this.customFields["ContactURL0"] };
	this.getCustom0 = function () { return this.customFields["Custom0"] };
	this.getCustom1 = function () { return this.customFields["Custom1"] };
	this.getCustom2 = function () { return this.customFields["Custom2"] };
	this.getCustom3 = function () { return this.customFields["Custom3"] };
	this.getCustom4 = function () { return this.customFields["Custom4"] };
	this.getCustom5 = function () { return this.customFields["Custom5"] };
}
function IsContactValid(oContact) {
	// das ist die JavaScript-Variante von: estos\common\libs\ETool\ENetDatabaseContact.cpp(366), ENetDatabaseContact::IsValid()
	try {
		return oContact.u8sDisplayName.length && oContact.u8sFirstName.length && oContact.u8sLastName.length && oContact.u8sCompany.length;
	} catch (e) {
		return false;
	}
}

/*
 * ab hier kommt alles was ueber den "/actionManagerXXXX" host-support laeuft
 *
 * task-psi: mergen => HelloCWE, cherry-pick => develop
 * estos\etapimonitor\ActionManagerWebRequestHandler.cpp(4)
 */
const ROUTE_ACTIONMANAGERWEBREQUEST = "/actionManagerWebRequest/";
function callActionManagerWebRequest(sOperationName, oAsnNetDatabaseContact) {
	const sUriAPI = "http://ecticlient.local" + ROUTE_ACTIONMANAGERWEBREQUEST + sOperationName,
		oArgument = {
			_type: "AsnNetDatabaseContact",
			u8sDisplayName: sOperationName + " Demo",
			u8sCompany: "estos GmbH",
			customFields: [
				{ key: "Custom0", value: "http://crm.estos.de/sfa/conts/edit.aspx?id=D2111735-2370-EB11-B679-005056870022" },
				{ key: "ContactURL0", value: "dynamicsnav://nav-srv.estos.de:7046/ESTOS_LIVE/runpage?page=5050&bookmark=27%3buhMAAAJ7CDUAMAAwADAAMwA5ADQAMA%3d%3d" }
			]
		},
		oInit = {
			method: 'POST',
			headers: {
				'Content-Type': 'application/json'
			}, // https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/X-Content-Type-Options
			body: JSON.stringify(oArgument)
		};

/*
* Die SNACC::AsnNetDatabaseContact::JEnc funktionen im allgemeinen das SNACC::AsnNetDatabaseContact::JEnc im speziellen
* machen leider kein vollstaendiges Encode wie es fuer ein JavaScript noetig/sinnvoll waehre.
* Ohne den "_type" kann ich den fuer die umkehrfunktion noetigen type nicht ermitteln.
* Solange die hier uebergebenen contacte ueber die localBPIInformation geliefert werden
* erledigt das: estos\etapimonitor\EClientCallInformation.cpp(166), EClientCallInformation::JEnc()
* Wenn dieser assert zuschlaegt:
* pruefen ob hier WIRKLICH ein kompatibler AsnNetDatabaseContact erzeugt wurde
* und konsequent den _type auf: "AsnNetDatabaseContact" setzen.
*/
	console.assert("AsnNetDatabaseContact" === oAsnNetDatabaseContact._type, "invalid argument or missing type information");

	// https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API/Using_Fetch#supplying_request_options
	return fetch(sUriAPI, oInit)
		.then(response => response.json());
}
