function buildForwardUri(oLocalBPIInformationArgument)
{
	if (0 === oLocalBPIInformationArgument.Note.length) throw Error("empty Note");
	const sBody = oLocalBPIInformationArgument.Note + "%0A";

	// hier steht die EMail von dem abwesenden Kollegen
	// ein mitarbeiter (vermutlich die sekretrin) hat das gespraech per PickUp an bzw. uebernommen
	// also stecken wir die addresse gleich in das An: feld
	const sEMail = getPriorityEMail(oLocalBPIInformationArgument.RedirectingContact); // RedirectingContact, RemoteContact
	if (0 === sEMail.length) throw Error("no Redirecting");

	const sSubject = "Anruf in Abwesenheit von [" + oLocalBPIInformationArgument.RemoteNumberSC + "] " + oLocalBPIInformationArgument.RemoteContact.u8sDisplayName;

	// strBody += oContact.RemoteNumber;
	// http://www.ianr.unl.edu/internet/mailto.html
	// window.open();
	return "mailto:" + sEMail + "?subject=" + sSubject + "&body=" + sBody;
}
function myHostMessageHandler(arg) {
/*
* WebView2 (Chrome) bietet nur EINEN ein-sprung-punkt
* d.H. ALLE unsere Hosts (CWebViewHost, CHostContactDetails, ...) muessen ueber ein uebergreifenden NamesSchema
* verfuegen so das eine Messsage EINDEUTIG zugeordnet werden kann!
*/
	try {
/*
* wir vermeiden aktuell das ermitteln der BPIInformation aus generischen Asn... methoden.
* Begruendung: Aufwand!
* wir muessten uns hier explizit fuer ALLE moeglichen channels subscriben.
* wir muessten snapshot methoden fuer ALLE moeglichen channels implementieren ...
*
* siehe: estos\etapimonitor\EClientCallInformation.cpp(164)
*/
		if (99999 === arg.data.invokeID && "localBPIInformation" === arg.data.operationName) {
			let oLocalBPIInformationArgument = arg.data.argument;

/*
* Hinweise:
* Der Host garantiert keine aenderung als Grundlage fuer ein Event.
* Der Aufruf von requestNewObjectLayout() fuehrt garantiert zu einem onHostMessage().
* Es ist zu garantieren das man hier keine end-los-schleife verbaut.
* onHostMessage() -> requestNewObjectLayout() -> und wieder von vorne ...
* Fazit:
* der Trick liegt in der requestNewObjectLayout() funktion und der tatsache das
* diese aufgerufen wird nachdem feststeht wie gross es denn sein soll!
			console.log("DatabaseName:", oLocalBPIInformationArgument.RemoteContact.u8sDatabaseName);
*/

/*
* wir bestimmen die dimension/groesse (UseCase: Valid/Invalid) fuer die extension gem. status:
* 1.) Redirecting Scenario: RedirectingContact.bValid
* 2.) Type: PBX od. Softphone (nur diese verfuegen ueber ein Notiz Feld)
* 2.a.) wenn man einen Softphone-Call PickUp'ed/Redirect'ed koennte man ja einfache den Chat input an den redirectenden fowarden ...
*/
			// console.log("RedirectingContact.bValid:", oLocalBPIInformationArgument.RedirectingContact.bValid);
			// console.log("Note:", oLocalBPIInformationArgument.Note);
			try {
				document.getElementById('lnkForwardNote').href = buildForwardUri(oLocalBPIInformationArgument);
				document.getElementById('lnkForwardNote').textContent = getPriorityEMail(oLocalBPIInformationArgument.RedirectingContact);
				$("#content").show();
				$("#expanded").show();
				$("#collapsed").hide();
			} catch (e) {
				$("#content").hide();
				$("#expanded").hide();
				$("#collapsed").show();
				document.getElementById('lnkForwardNote').removeAttribute("href");
			}
			requestNewObjectLayout();
		}
	} catch (e) {
	}
}

window.addEventListener("load", () => {
	try {
/*
* most simple and recommended usage of: cweapi.js
* - do a one shot trigger of layout with fixed size
* - setup event handler to interact with the host
*/
		initCWE(document.body.scrollHeight, myHostMessageHandler);
	} catch (e) {
	}
});
